package org.objectweb.eclipsespeedo;

import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.core.runtime.IPluginRegistry;
import org.eclipse.core.runtime.Platform;

/**
 * IEclipseSpeedoConstants enumerates all the constants used by the plugin.
 */
public interface IEclipseSpeedoConstants
{
	//Global
	String PLUGIN_ID = "org.objectweb.eclipsespeedo";
	String VERSION = "1.0.0";
	String PREFIX = PLUGIN_ID + ".";
	String PROJECT_NATURE_ID = PREFIX + "EclipseSpeedoNature";

	String JDO_LIB_CONTAINER = "org.objectweb.eclipsespeedo.JDO_CONTAINER";
	String DELIMITER_JDO_LIB_CONTAINER = "/";


	//Common preference Page
	IPluginRegistry registry = Platform.getPluginRegistry();
	IPluginDescriptor desciptor = registry.getPluginDescriptor(IEclipseSpeedoConstants.PLUGIN_ID);
	String PREF_VENDOR_NAME = PREFIX + "VendorName";
	String PREF_METADATA_DOC_TYPE = PREFIX + "MetadataDOCTYPE";
	//String METADATA_DOC_TYPE = "PUBLIC \"-//Sun Microsystems, Inc.//DTD Java Data Objects Metadata 1.0//EN\"   \"file:/"+Platform.getLocation().removeLastSegments(1).toOSString()+File.separator+"plugins"+File.separator+IEclipseSpeedoConstants.PLUGIN_ID+"_"+IEclipseSpeedoConstants.VERSION+File.separator+"jdo.dtd\"";
	String METADATA_DOC_TYPE = "PUBLIC \"-//Sun Microsystems, Inc.//DTD Java Data Objects Metadata 1.0//EN\"   \"file:/jdo.dtd\"";
	//String METADATA_DOC_TYPE = "SYSTEM \"jdo.dtd\"";
	String METADATA_DEFAULT_EXT = "jdo";
	String VENDOR_DEFAULT_NAME = "Speedo";

	//enhancer preference page
	String ENHANCER_REFERENCE_NAME = "Reference(Sun)";

	String DELIMITER_ENHANCER_CONFIGURATION = ";";
	String DELIMITER_ENHANCER_NAME = "=";
	String DELIMITER_ENHANCER_MAIN = "@";
	String DELIMITER_ENHANCER_IMP_JAR = "&";
	String DELIMITER_ENHANCER_PREFIX_CLASS = "#";
	String DELIMITER_ENHANCER_PREFIX_JDO = "|";
	String DELIMITER_ENHANCER_PM_FACTORY = "!";
	String DELIMITER_ENHANCER_METADATA_DOCTYPE = "^";
	String DELIMITER_ENHANCER_JDO_101_SCHEME = "$";
	String DELIMITER_ENHANCER_JARS = ",";
	String ENHANCER_NO_VALUE = "null";
	//	String ENABLE_REDIRECT_ENHANCER_OUTPUT = "ENABLE.REDIRECT.ENHANCER.OUTPUT";

	//EnhancerConfig Default 
	String ENHANCERCONFIG_DEFAULT = "DefaultEnhancer";
	String ENHANCERCONFIG_REFERENCE_NAME = "Reference(Sun)";
	String ENHANCERCONFIG_REFERENCE_ID = "com.versant.eclipse.jdo.driver.sun";
	String ENHANCERCONFIG_REFERENCE_JDO = "jdo.jar";
	String ENHANCERCONFIG_REFERENCE_BTREE = "btree.jar";
	String ENHANCERCONFIG_REFERENCE_JDO_IMP = "jdori.jar";
	String ENHANCERCONFIG_REFERENCE_MAIN = "com.sun.jdori.enhancer.Main";
	String ENHANCERCONFIG_REFERENCE_PM_FACTORY =
		"com.sun.jdori.fostore.FOStorePMF";

	//METADATA_DTD ELEMENT type
	String METADATA_DTD_ELEMENT_PACKAGE = "package";
	String METADATA_DTD_ELEMENT_CLASS = "class";
	String METADATA_DTD_ELEMENT_FIELD = "field";
	String METADATA_DTD_ELELENT_EXTENSION = "extension";
	String METADATA_DTD_ELEMENT_COLLECTION = "collection";
	String METADATA_DTD_ELEMENT_MAP = "map";
	String METADATA_DTD_ELEMENT_ARRAY = "array";
	String METADATA_DTD_DOCTYPE = "jdo.dtd";

	String METADATA_DTD_ATT_NAME = "name";

	//METADATA_DTD !ELEMENT CLASS ATTRIBUTES
	String METADATA_DTD_ATT_IDENTITY_TYPE = "identity-type";
	String METADATA_DTD_ATT_OBJECTID_CLASS = "objectid-class";
	String METADATA_DTD_ATT_REQUIRES_EXTENT = "requires-extent";
	String METADATA_DTD_ATT_PERSISTENCE_CAPABLE_SUPERCLASS =
		"persistence-capable-superclass";
	String METADATA_DTD_ATT_PERSISTENCE_MANAGER_FACTORY_CLASS =
		"javax.jdo.PersistenceManagerFactoryClass";

	//METADATA_DTD !ELEMENT FIELD ATTRIBUTES
	String METADATA_DTD_ATT_PERSISTENCE_MODIFIER = "persistence-modifier";
	String METADATA_DTD_ATT_PRIMARY_KEY = "primary-key";
	String METADATA_DTD_ATT_NULL_VALUE = "null-value";
	String METADATA_DTD_ATT_DEFAULT_FETCH_GROUP = "default-fetch-group";
	String METADATA_DTD_ATT_EMBEDDED = "embedded";

	//METADATA_DTD !ELEMENT EXTENSION ATTRIBUTES
	String METADATA_DTD_ATT_VENDOR_NAME = "vendor-name";
	String METADATA_DTD_ATT_KEY = "key";
	String METADATA_DTD_ATT_VALUE = "value";
	String METADATA_FILE = "metadata.jdo";
	String PACKAGE_METADATA_NAME = "package";
	String PACKAGE_METADATA_FILE = "package.jdo";

	//	The default values for the preferences
	String DEFAULT_ENHANCERS =
		"Reference (SUN)"
			+ DELIMITER_ENHANCER_NAME
			+ "com.sun.jdori.enhancer.Main"
			+ DELIMITER_ENHANCER_MAIN
			+ "D:\\ECLIPSEJDO\\SUN\\RI\\src\\jdori.jar"
			+ DELIMITER_ENHANCER_IMP_JAR
			+ ENHANCER_NO_VALUE
			+ DELIMITER_ENHANCER_PREFIX_CLASS
			+ ENHANCER_NO_VALUE
			+ DELIMITER_ENHANCER_PREFIX_JDO
			+ ENHANCER_NO_VALUE
			+ DELIMITER_ENHANCER_PM_FACTORY
			+ METADATA_DOC_TYPE
			+ DELIMITER_ENHANCER_METADATA_DOCTYPE
			+ DELIMITER_ENHANCER_JARS
			+ "D:\\ECLIPSE JDO\\SUN\\RI\\src\\jdo.jar";
}
