/*******************************************************************************
 * Copyright (c) 2002, 2003 Eteration Bilisim A.S., Naci Dai and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the GNU Lesser General Public License (LGPL)
 * which accompanies this distribution, and is available at
 *  http://www.gnu.org/licenses/lgpl.html
 * 
 * Contributors:
 *     Eteration Bilisim A.S. - initial API and implementation
 *     Naci M. Dai
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by the
 *        Eteration Bilisim A.S and Naci Dai (http://www.eteration.com/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "Lomboz", "ObjectLearn" and "Eteration" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written
 *    permission, please contact info@eteration.com.
 *
 * 5. Products derived from this software may not be called "Lomboz"
 *    nor may "Lomboz" appear in their names without prior written
 *    permission of the Eteration Bilisim A.S.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Eteration Bilisim A.S.  For more
 * information on eteration, please see
 * <http://www.eteration.com/>.
 ***************************************************************************/
package org.objectweb.eclipsespeedo.drivers.xml;

import java.util.ArrayList;
import java.util.List;

import org.xml.sax.Attributes;


/**
 * Build a new BeanGroup object.
 *  
 * @author B. Grkem ERCAN
 */
public class BeanGroupBuildConfig implements BuildConfigInterface
{
	private Beangroup beangroup = new Beangroup();
	private List beans = new ArrayList();
	private Bean currentBean = null;
	public BeanGroupBuildConfig()
	{
		super();
	}

	/**
	 * @see com.objectlearn.jdt.xml.BuildConfigInterface#getConfigObject()
	 */
	public Object getConfigObject()
	{
		if (this.beans.size()>0)
			beangroup.setBeans(this.beans);
		return beangroup;
	}

	/**
	 * @see com.objectlearn.jdt.xml.BuildConfigInterface#assesTagEnd(String, String)
	 */
	public void assesTagEnd(String qualName, String tagName, String content)
	{
		if (tagName.equals("beanClass"))
			currentBean.setBeanClass(content);
		if (tagName.equals("type"))
			currentBean.setType(content);
		if (tagName.equals("bean"))
		{
			beans.add(currentBean);
		}
	}

	/**
	 * @see com.objectlearn.jdt.xml.BuildConfigInterface#assesTagStart(String)
	 */
	public void assesTagStart(String qualName, String tagName, Attributes attributes)
	{
		if (tagName.equals("bean"))
			currentBean = new Bean();

	}

}
