/*******************************************************************************
 * Copyright (c) 2002, 2003 Eteration Bilisim A.S., Naci Dai and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the GNU Lesser General Public License (LGPL)
 * which accompanies this distribution, and is available at
 *  http://www.gnu.org/licenses/lgpl.html
 * 
 * Contributors:
 *     Eteration Bilisim A.S. - initial API and implementation
 *     Naci M. Dai
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by the
 *        Eteration Bilisim A.S and Naci Dai (http://www.eteration.com/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "Lomboz", "ObjectLearn" and "Eteration" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written
 *    permission, please contact info@eteration.com.
 *
 * 5. Products derived from this software may not be called "Lomboz"
 *    nor may "Lomboz" appear in their names without prior written
 *    permission of the Eteration Bilisim A.S.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Eteration Bilisim A.S.  For more
 * information on eteration, please see
 * <http://www.eteration.com/>.
 ***************************************************************************/
package org.objectweb.eclipsespeedo.drivers.xml;

import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;
/**
 * 
 * @author B. Grkem ERCAN
 */
public class Beangroup
{
	private List _Beans = new ArrayList();
	/**
	 * Method getBeans.
	 * @return List
	 */
	public List getBeans()
	{
		return _Beans;
	}

	/**
	 * Method setBeans.
	 * @param beans
	 */
	public void setBeans(List beans)
	{
		this._Beans = beans;
	}
	/**
	 * Method deleteBeans.
	 */
	public void deleteBeans()
	{
		_Beans = null;

	}
	/**
	 * Method emptyBeans.
	 */
	public void emptyBeans()
	{
		_Beans = new ArrayList();
	}
	/**
	 * Write the contents of this beanGroup to out.
	 * @param out XML file to persist to.
	 */
	public void persistToXML(FileOutputStream out) throws IOException
	{
		OutputStreamWriter streamwriter = new OutputStreamWriter(out);
		BufferedWriter buw = new BufferedWriter(streamwriter);
		String s = streamwriter.getEncoding();
		if (s.equals("UTF8"))
			s = "UTF-8";
		else if (s.equals("ASCII"))
			s = "US-ASCII";

		buw.write("<?xml version=\"1.0\" encoding=\"" + s + "\"?>");
		buw.newLine();
		buw.write("<beangroup>");
		buw.newLine();

		for (int i = 0; i < this._Beans.size(); i++)
		{
			buw.write("  ");
			buw.write("<bean>");
			buw.newLine();
			//BeanClass
			buw.write("    ");
			buw.write("<beanClass>");
			buw.write(((Bean) this._Beans.get(i)).getBeanClass());
			buw.write("</beanClass>");
			buw.newLine();
			//Type
			buw.write("    ");
			buw.write("<type>");
			buw.write(((Bean) this._Beans.get(i)).getType());
			buw.write("</type>");
			buw.newLine();
			// close bean
			buw.write("  ");
			buw.write("</bean>");
			buw.newLine();

		}

		buw.write("</beangroup>");
		buw.newLine();
		buw.flush();
		buw.close();
	}
}
