/*
 * Created on May 7, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */

package org.objectweb.eclipsespeedo.drivers.xml;

import java.io.File;
import java.io.IOException;

import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;


public class ClasspathItem {
	public static final int VARIABLE = 0;
	public static final int ABSOLUTE = 1;
	private static Logger logger = EclipseSpeedoPlugin.loggerFactory.getLogger(ClasspathItem.class.getName());
	
	int type;
	String classpath;

	/**
	 * @return String
	 */
	public String getClasspath() {
		return classpath;
	}

	/**
	 * @return int
	 */
	public int getType() {
		return type;
	}

	/**
	 * Sets the classpath.
	 * @param classpath The classpath to set
	 */
	public void setClasspath(String classpath) {
		this.classpath = classpath;
	}

	/**
	 * Sets the type.
	 * @param type The type to set
	 */
	public void setType(int type) {
		this.type = type;
	}
	public void setTypeStr(String typeStr) {
		if ("variable".equals(typeStr)) {
			type = VARIABLE;
		} else if ("absolute".equals(typeStr)) {
			type = ABSOLUTE;
		}

	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "<jar type=\""
			+ (type == 0 ? "variable" : "absolute")
			+ "\">"
			+ this.getClasspath()
			+ "</jar>";
	}

	public boolean exists() {
		File f = new File(this.classpath);
		return f.exists();
	}

	public void setRawClasspathFor(DriverDefinition def, String rawPath) {
		File f = new File(rawPath);
		if (!f.exists())
			return;
		try {
			String path = f.getCanonicalPath().replace('\\', '/');
			setType(ABSOLUTE);
			setClasspath(path);
		} catch (IOException e) {
			logger.log(BasicLevel.ERROR, e);
			setType(ABSOLUTE);
			setClasspath(rawPath);
		}

	}

}
