/*
 * Created on May 7, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */
 
package org.objectweb.eclipsespeedo.drivers.xml;


public class DriverDefinitionProperty {
	public static final int STRING = 0;
	public static final int FILE = 1;
	public static final int DIRECTORY = 2;
	public static final int BOOLEAN = 3;
	public static final int COMBO = 4;
	public static final int EFOLDER = 5;
	public static final int PCLASSPATH = 6;
			
	private String id;
	private String label;
	private int type;
	private String defaultValue;
	private boolean modifiable = true;
	private Object tempValue;
	private String desc = "";

	/**
	 * @return String
	 */
	public String getDefaultValue() {
		return defaultValue;
	}

	/**
	 * @return String
	 */
	public String getId() {
		return id;
	}

	/**
	 * @return String
	 */
	public String getLabel() {
		return label;
	}

	/**
	 * @return int
	 */
	public int getType() {
		return type;
	}

	/**
	 * Sets the defaultValue.
	 * @param defaultValue The defaultValue to set
	 */
	public void setDefaultValue(String defaultValue) {
		this.defaultValue = defaultValue;
	}

	/**
	 * Sets the id.
	 * @param id The id to set
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * Sets the label.
	 * @param label The label to set
	 */
	public void setLabel(String label) {
		this.label = label;
	}

	/**
	 * Sets the type.
	 * @param type The type to set
	 */
	public void setType(int type) {
		this.type = type;
	}
	public void setTypeFromStr(String str) {
		if ("string".equals(str))
			this.type = STRING;
		else if ("directory".equals(str))
			this.type = DIRECTORY;
		else if ("file".equals(str))
			this.type = FILE;
		else if ("boolean".equals(str))
			this.type = BOOLEAN;
		else if ("efolder".equals(str))
			this.type = EFOLDER;
		else if ("combo".equals(str))
			this.type = COMBO;
		else if ("pclasspath".equals(str))
			this.type = PCLASSPATH;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "\n<property id=\""
			+ this.getId()
			+ "\"\n\tlabel=\""
			+ this.getLabel()
			+ "\"\n\ttype=\""
			+ (type == DIRECTORY
				? "directory"
				: (type == STRING
					? "string"
					: (type == FILE
						? "file"
						: (type == BOOLEAN 
							? "boolean" 
							: (type == COMBO
								? "combo"
								: (type == EFOLDER
									? "efolder"
									: (type == PCLASSPATH
										? "pclasspath":"undefined")))))))
			+ "\"\n\tmodifiable=\""
			+ (this.isModifiable()?"true":"false")
			+ "\"\n\tdescription=\""
			+ this.getDesc()
			+ "\"\n\tdefault=\""
			+ this.getDefaultValue()
			+ "\" />";
	}

	/**
	 * @return
	 */
	public boolean isModifiable() {
		return modifiable;
	}

	/**
	 * @param b
	 */
	public void setModifiable(String b) {
		if (b == null) return;
		if (b.equals("false")) modifiable = false;
	}

	/**
	 * @return
	 */
	public Object getTempValue() {
		return tempValue;
	}

	/**
	 * @param object
	 */
	public void setTempValue(Object object) {
		tempValue = object;
	}

	/**
	 * @return
	 */
	public String getDesc() {
		return desc;
	}

	/**
	 * @param string
	 */
	public void setDesc(String string) {
		if (string!=null) desc = string;
	}

}
