/*
 * Created on Apr 22, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */
package org.objectweb.eclipsespeedo.enhancer;

import java.io.File;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.internal.core.JavaProject;
import org.eclipse.jface.viewers.StructuredSelection;
import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.eclipsespeedo.project.EclipseSpeedoProjectHelper;
import org.objectweb.eclipsespeedo.project.ProjectProperties;


public class CmdLineHelper {

	private IJavaProject curproject;
	
	
	public CmdLineHelper() {
		EclipseSpeedoPlugin p = EclipseSpeedoPlugin.getDefault();
		StructuredSelection ss = (StructuredSelection) p.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
		try {
			this.curproject = (JavaProject) ss.getFirstElement();
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
	
	public IJavaProject getProject(){
		return curproject;
	}
	
	public String getSpeedoArgs(){
		try {
			return "-v -sp \""+
					Platform.getLocation().toOSString()+curproject.getPath().toOSString()+File.separator+"enhancer.properties"+
					"\" -log \""+
					Platform.getLocation().toOSString()+curproject.getPath().toOSString()+File.separator+"logs.properties"+
					"\" -i \""+
					ProjectProperties.getSelDriverProperty(curproject.getProject(), "ifolder")+
					"\" -d \""+
					ProjectProperties.getSelDriverProperty(curproject.getProject(), "ofolder")+"\"";
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
	
	public String getArgs(){
		try {
			String metadataFiles = EclipseSpeedoProjectHelper.collectAllFiles(curproject, "jdo");
			String classFiles = EclipseSpeedoProjectHelper.collectAllFiles(curproject, "class");
			return "-v -s . "+metadataFiles+" "+classFiles;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
	
	
	public IPath getProjectAbsolutePath(){
		return new Path(Platform.getLocation().toOSString()+curproject.getPath().toOSString()+File.separator);
	}
}
