/*
 * Created on June 5, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */

package org.objectweb.eclipsespeedo.jdoextensions.xml;

import java.util.ArrayList;

import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.util.monolog.api.Logger;
import org.xml.sax.Attributes;

public class JDOExtensionsConfiguration implements BuildExtensionsInterface {


	public static final int JDO = 0;
	public static final int PACKAGE = 1;
	public static final int CLASS = 2;
	public static final int FIELD = 3;
	public static final int COLLECTION = 4;
	public static final int MAP = 5;
	
	private int curextensionlevel=-1;
	private VendorExtensions curVendorExtensions;
	private ArrayList exts = new ArrayList();
	private String Vendor = "";

	private Logger logger = EclipseSpeedoPlugin.loggerFactory.getLogger(JDOExtensionsConfiguration.class.getName());
	

	public void assesTagEnd(String qName, String tagName, String content) {
		if ("jdo".equals(tagName)){
			curVendorExtensions.setExtensions(exts);
		}
	}

	public void assesTagStart(String qName, String tagName, Attributes attributes) {
		if ("jdo".equals(tagName)) {
			curVendorExtensions = new VendorExtensions(attributes.getValue("vendor-name"), attributes.getValue("driver-name"));
			this.Vendor = attributes.getValue("vendor-name");
			curextensionlevel = JDO;
		} else if ("package".equals(tagName)){
			curextensionlevel = PACKAGE;
		} else if ("class".equals(tagName)){
			curextensionlevel = CLASS;
		} else if ("field".equals(tagName)){
			curextensionlevel = FIELD;
		} else if ("collection".equals(tagName)){
			curextensionlevel = COLLECTION;
		} else if ("map".equals(tagName)){
			curextensionlevel = MAP;
		} else if ("key".equals(tagName)) {
			Extension ext = new Extension();
			ext.setVendor(Vendor);
			ext.setKey(attributes.getValue("name"));
			ext.setTypeFromStr(attributes.getValue("type"));
			ext.setDefaultValue(attributes.getValue("value"));
			ext.setDesc(attributes.getValue("description"));
			ext.setLevel(curextensionlevel);
			exts.add(ext);
		}
	}

	public Object getConfigObject() {
		return curVendorExtensions;
	}
}
