/*
 * Created on June 5, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */
 
package org.objectweb.eclipsespeedo.jdoextensions.xml;

import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.core.runtime.Path;
import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;




public class JDOExtensionsManager {
	
	ArrayList VendorExtensions;
	File sourceDir;
	Logger logger = EclipseSpeedoPlugin.loggerFactory.getLogger(this.getClass().getName());
	
	public JDOExtensionsManager(Path installUrl) {
		logger.log(BasicLevel.DEBUG, "Creating driver definition manager["+installUrl+"]");
		String s1 = installUrl.append("/jdoextensions").toOSString();
		sourceDir = new File(s1);
		refresh();
	}
	
	
	public void refresh() {
		VendorExtensions = scanFiles(sourceDir);
	}
	

	
	
	private  ArrayList scanFiles(File dir) {
		logger.log(BasicLevel.DEBUG, "Entering DriverDefinitionManager.ScanFiles()");
		ArrayList all = new ArrayList();
		try {
			if(dir.isDirectory()){
				File[] allDrivers = dir.listFiles(new FilenameFilter(){
					public boolean accept(File dir, String name) {
						if(name.endsWith(".extension"))
							return true;
						return false;
					}
				});
				
				for (int i = 0; i < allDrivers.length; i++) {
					File file = allDrivers[i];
					logger.log(BasicLevel.DEBUG, "Starting reading driver definition["+file+"]");
					VendorExtensions def = (VendorExtensions) ExtensionsBuilder.getVendorExtensions(file.getCanonicalPath());
					logger.log(BasicLevel.DEBUG, "Ending reading driver definition["+file+"]");
					if(def != null){
						def.setDefinitionFile(file);
						all.add(def);
					}
				}
			}
		} catch (IOException e) {
			logger.log(BasicLevel.ERROR,e);
		}
		catch (Exception e) {
				   logger.log(BasicLevel.ERROR,e);
		}
		return all;
	}

	/**
	 * @return ArrayList
	 */
	public ArrayList getVendorExtensions() {
		return VendorExtensions;
	}

	/**
	 * @return ArrayList
	 */
	public VendorExtensions getVendorExtensionsNamed(String name) {
		refresh();
		Iterator defs = getVendorExtensions().iterator();
		while (defs.hasNext()) {
			VendorExtensions elem = (VendorExtensions) defs.next();
			if(name.equalsIgnoreCase(elem.getVendor())) return elem;			
		}		
		return null;
	}

	/**
	 * @return ArrayList
	 */
	public VendorExtensions getDriverExtensions(String name) {
		refresh();
		Iterator defs = getVendorExtensions().iterator();
		while (defs.hasNext()) {
			VendorExtensions elem = (VendorExtensions) defs.next();
			if(name.equalsIgnoreCase(elem.getVendor())) return elem;			
		}		
		return null;
	}


	/**
	 * Sets the definitions.
	 * @param definitions The definitions to set
	 */
	public void setVendorExtensions(ArrayList ve) {
		this.VendorExtensions = ve;
	}

}
