/*
 * Created on June 5, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */
 
package org.objectweb.eclipsespeedo.jdoextensions.xml;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;

import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.util.monolog.api.Logger;


public class VendorExtensions {
	
	private File definitionFile;
	private String vendor;
	private String driver;
	private ArrayList extensions;


	private static Logger logger = EclipseSpeedoPlugin.loggerFactory.getLogger(VendorExtensions.class.getName());
	
	public VendorExtensions(String v, String d) {
		vendor = v;
		driver = d;
		extensions = new ArrayList();
	}

	public Extension getExtensionNamed(String s){
		for (Iterator ite = extensions.iterator(); ite.hasNext();){
			Extension cur = (Extension) ite.next();
			if (cur.getKey().equalsIgnoreCase(s)) return cur;
		}
		return null;
	}
	
	/**
	 * @return File
	 */
	public File getDefinitionFile() {
		return definitionFile;
	}

	/**
	 * Sets the definitionFile.
	 * @param definitionFile The definitionFile to set
	 */
	public void setDefinitionFile(File definitionFile) {
		this.definitionFile = definitionFile;
	}


	/**
	 * @return
	 */
	public String getDriver() {
		return driver;
	}

	/**
	 * @return
	 */
	public String getVendor() {
		return vendor;
	}

	/**
	 * @param string
	 */
	public void setDriver(String string) {
		driver = string;
	}

	/**
	 * @param string
	 */
	public void setVendor(String string) {
		vendor = string;
	}

	/**
	 * @return
	 */
	public ArrayList getExtensions() {
		return extensions;
	}

	/**
	 * @param list
	 */
	public void setExtensions(ArrayList list) {
		extensions = list;
	}

}
