package org.objectweb.eclipsespeedo.metadata;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->A representation of the literals of the enumeration '
 * <em><b>JDO Identity Type</b></em>', and utility methods for working
 * with them. <!-- end-user-doc -->
 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOIdentityType()
 * @model
 * @generated
 */
public final class JDOIdentityType extends AbstractEnumerator
{
	/**
	 * The '<em><b>None</b></em>' literal value. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #NONE_LITERAL @model name="none" @generated @ordered
	 */
	public static final int NONE = 0;

	/**
	 * The '<em><b>Application</b></em>' literal value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * 
	 * @see #APPLICATION_LITERAL @model name="application" @generated @ordered
	 */
	public static final int APPLICATION = 1;

	/**
	 * The '<em><b>Datastore</b></em>' literal value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * 
	 * @see #DATASTORE_LITERAL @model name="datastore" @generated @ordered
	 */
	public static final int DATASTORE = 2;

	/**
	 * The '<em><b>Nondurable</b></em>' literal value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * 
	 * @see #NONDURABLE_LITERAL @model name="nondurable" @generated @ordered
	 */
	public static final int NONDURABLE = 3;

	/**
	 * The '<em><b>None</b></em>' literal object. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>None</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #NONE @generated @ordered
	 */
	public static final JDOIdentityType NONE_LITERAL =
		new JDOIdentityType(NONE, "none");

	/**
	 * The '<em><b>Application</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Application</b></em>' literal object
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #APPLICATION @generated @ordered
	 */
	public static final JDOIdentityType APPLICATION_LITERAL =
		new JDOIdentityType(APPLICATION, "application");

	/**
	 * The '<em><b>Datastore</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Datastore</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #DATASTORE @generated @ordered
	 */
	public static final JDOIdentityType DATASTORE_LITERAL =
		new JDOIdentityType(DATASTORE, "datastore");

	/**
	 * The '<em><b>Nondurable</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Nondurable</b></em>' literal object
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #NONDURABLE @generated @ordered
	 */
	public static final JDOIdentityType NONDURABLE_LITERAL =
		new JDOIdentityType(NONDURABLE, "nondurable");

	/**
	 * An array of all the '<em><b>JDO Identity Type</b></em>'
	 * enumerators. <!-- begin-user-doc --><!-- end-user-doc -->@generated
	 */
	private static final JDOIdentityType[] VALUES_ARRAY =
		new JDOIdentityType[] {
			NONE_LITERAL,
			APPLICATION_LITERAL,
			DATASTORE_LITERAL,
			NONDURABLE_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>JDO Identity Type</b></em>'
	 * enumerators. <!-- begin-user-doc --><!-- end-user-doc -->@generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>JDO Identity Type</b></em>' literal with the
	 * specified name. <!-- begin-user-doc --><!-- end-user-doc -->@generated
	 */
	public static JDOIdentityType get(String name)
	{
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			JDOIdentityType result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>JDO Identity Type</b></em>' literal with the specified value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @generated
	 */
	public static JDOIdentityType get(int value)
	{
		switch (value) {
			case NONE: return NONE_LITERAL;
			case APPLICATION: return APPLICATION_LITERAL;
			case DATASTORE: return DATASTORE_LITERAL;
			case NONDURABLE: return NONDURABLE_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->@generated
	 */
	private JDOIdentityType(int value, String name)
	{
		super(value, name);
	}

} //JDOIdentityType
