

package org.objectweb.eclipsespeedo.metadata;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->A representation of the literals of the enumeration '
 * <em><b>JDO Null Value</b></em>', and utility methods for working with
 * them. <!-- end-user-doc -->
 * @see EclipseSpeedo.metadata.MetadataPackage#getJDONullValue()
 * @model
 * @generated
 */
public final class JDONullValue extends AbstractEnumerator
{
	/**
	 * The '<em><b>None</b></em>' literal value. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #NONE_LITERAL @model name="none" @generated @ordered
	 */
	public static final int NONE = 0;

	/**
	 * The '<em><b>Exception</b></em>' literal value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * 
	 * @see #EXCEPTION_LITERAL @model name="exception" @generated @ordered
	 */
	public static final int EXCEPTION = 1;

	/**
	 * The '<em><b>Default</b></em>' literal value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * 
	 * @see #DEFAULT_LITERAL @model name="default" @generated @ordered
	 */
	public static final int DEFAULT = 2;

	/**
	 * The '<em><b>None</b></em>' literal object. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>None</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #NONE @generated @ordered
	 */
	public static final JDONullValue NONE_LITERAL =
		new JDONullValue(NONE, "none");

	/**
	 * The '<em><b>Exception</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Exception</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #EXCEPTION @generated @ordered
	 */
	public static final JDONullValue EXCEPTION_LITERAL =
		new JDONullValue(EXCEPTION, "exception");

	/**
	 * The '<em><b>Default</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Default</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #DEFAULT @generated @ordered
	 */
	public static final JDONullValue DEFAULT_LITERAL =
		new JDONullValue(DEFAULT, "default");

	/**
	 * An array of all the '<em><b>JDO Null Value</b></em>' enumerators.
	 * <!-- begin-user-doc --><!-- end-user-doc -->@generated
	 */
	private static final JDONullValue[] VALUES_ARRAY =
		new JDONullValue[] {
			NONE_LITERAL,
			EXCEPTION_LITERAL,
			DEFAULT_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>JDO Null Value</b></em>'
	 * enumerators. <!-- begin-user-doc --><!-- end-user-doc -->@generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>JDO Null Value</b></em>' literal with the
	 * specified name. <!-- begin-user-doc --><!-- end-user-doc -->@generated
	 */
	public static JDONullValue get(String name)
	{
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			JDONullValue result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>JDO Null Value</b></em>' literal with the specified value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @generated
	 */
	public static JDONullValue get(int value)
	{
		switch (value) {
			case NONE: return NONE_LITERAL;
			case EXCEPTION: return EXCEPTION_LITERAL;
			case DEFAULT: return DEFAULT_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->@generated
	 */
	private JDONullValue(int value, String name)
	{
		super(value, name);
	}

} //JDONullValue
