

package org.objectweb.eclipsespeedo.metadata;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->A representation of the literals of the enumeration '
 * <em><b>JDO Persistence Modifier</b></em>', and utility methods for
 * working with them. <!-- end-user-doc -->
 * @see EclipseSpeedo.metadata.MetadataPackage#getJDOPersistenceModifier()
 * @model
 * @generated
 */
public final class JDOPersistenceModifier extends AbstractEnumerator
{
	/**
	 * The '<em><b>Implied</b></em>' literal value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * 
	 * @see #IMPLIED_LITERAL @model name="implied" @generated @ordered
	 */
	public static final int IMPLIED = 0;

	/**
	 * The '<em><b>Persistent</b></em>' literal value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * 
	 * @see #PERSISTENT_LITERAL @model name="persistent" @generated @ordered
	 */
	public static final int PERSISTENT = 1;

	/**
	 * The '<em><b>Transactional</b></em>' literal value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @see #TRANSACTIONAL_LITERAL
	 * @model name="transactional"
	 * @generated
	 * @ordered
	 */
	public static final int TRANSACTIONAL = 2;

	/**
	 * The '<em><b>None</b></em>' literal value. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #NONE_LITERAL @model name="none" @generated @ordered
	 */
	public static final int NONE = 3;

	/**
	 * The '<em><b>Implied</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Implied</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #IMPLIED @generated @ordered
	 */
	public static final JDOPersistenceModifier IMPLIED_LITERAL =
		new JDOPersistenceModifier(IMPLIED, "implied");

	/**
	 * The '<em><b>Persistent</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Persistent</b></em>' literal object
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #PERSISTENT @generated @ordered
	 */
	public static final JDOPersistenceModifier PERSISTENT_LITERAL =
		new JDOPersistenceModifier(PERSISTENT, "persistent");

	/**
	 * The '<em><b>Transactional</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Transactional</b></em>' literal object
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #TRANSACTIONAL @generated @ordered
	 */
	public static final JDOPersistenceModifier TRANSACTIONAL_LITERAL =
		new JDOPersistenceModifier(TRANSACTIONAL, "transactional");

	/**
	 * The '<em><b>None</b></em>' literal object. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>None</b></em>' literal object isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #NONE @generated @ordered
	 */
	public static final JDOPersistenceModifier NONE_LITERAL =
		new JDOPersistenceModifier(NONE, "none");

	/**
	 * An array of all the '<em><b>JDO Persistence Modifier</b></em>'
	 * enumerators. <!-- begin-user-doc --><!-- end-user-doc -->@generated
	 */
	private static final JDOPersistenceModifier[] VALUES_ARRAY =
		new JDOPersistenceModifier[] {
			IMPLIED_LITERAL,
			PERSISTENT_LITERAL,
			TRANSACTIONAL_LITERAL,
			NONE_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>JDO Persistence Modifier</b></em>'
	 * enumerators. <!-- begin-user-doc --><!-- end-user-doc -->@generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>JDO Persistence Modifier</b></em>' literal with the specified name.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @generated
	 */
	public static JDOPersistenceModifier get(String name)
	{
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			JDOPersistenceModifier result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>JDO Persistence Modifier</b></em>' literal with the specified value.
	 * <!-- begin-user-doc --><!-- end-user-doc -->
	 * @generated
	 */
	public static JDOPersistenceModifier get(int value)
	{
		switch (value) {
			case IMPLIED: return IMPLIED_LITERAL;
			case PERSISTENT: return PERSISTENT_LITERAL;
			case TRANSACTIONAL: return TRANSACTIONAL_LITERAL;
			case NONE: return NONE_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->@generated
	 */
	private JDOPersistenceModifier(int value, String name)
	{
		super(value, name);
	}

} //JDOPersistenceModifier
