/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.objectweb.eclipsespeedo.metadata;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see EclipseSpeedo.metadata.MetadataFactory
 * @generated
 */
public interface MetadataPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "metadata";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///EclipseSpeedo/metadata.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "EclipseSpeedo.metadata";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	MetadataPackage eINSTANCE = org.objectweb.eclipsespeedo.metadata.impl.MetadataPackageImpl.init();

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOObjectImpl <em>JDO Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOObjectImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOObject()
	 * @generated
	 */
	int JDO_OBJECT = 8;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_OBJECT__EMPTY = 0;

	/**
	 * The number of structural features of the the '<em>JDO Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_OBJECT_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOArrayImpl <em>JDO Array</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOArrayImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOArray()
	 * @generated
	 */
	int JDO_ARRAY = 0;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_ARRAY__EMPTY = JDO_OBJECT__EMPTY;

	/**
	 * The feature id for the '<em><b>Embedded Element</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_ARRAY__EMBEDDED_ELEMENT = JDO_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Extensions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_ARRAY__EXTENSIONS = JDO_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>JDO Array</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_ARRAY_FEATURE_COUNT = JDO_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOModelElementImpl <em>JDO Model Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOModelElementImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOModelElement()
	 * @generated
	 */
	int JDO_MODEL_ELEMENT = 7;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MODEL_ELEMENT__EMPTY = JDO_OBJECT__EMPTY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MODEL_ELEMENT__NAME = JDO_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>JDO Model Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MODEL_ELEMENT_FEATURE_COUNT = JDO_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOClassImpl <em>JDO Class</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOClassImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOClass()
	 * @generated
	 */
	int JDO_CLASS = 1;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS__EMPTY = JDO_MODEL_ELEMENT__EMPTY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS__NAME = JDO_MODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS__OBJECT_ID_CLASS = JDO_MODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Requires Extent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS__REQUIRES_EXTENT = JDO_MODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Persistence Capable Superclass</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS__PERSISTENCE_CAPABLE_SUPERCLASS = JDO_MODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Identity Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS__IDENTITY_TYPE = JDO_MODEL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Fields</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS__FIELDS = JDO_MODEL_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Extensions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS__EXTENSIONS = JDO_MODEL_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the the '<em>JDO Class</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_CLASS_FEATURE_COUNT = JDO_MODEL_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOCollectionImpl <em>JDO Collection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOCollectionImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOCollection()
	 * @generated
	 */
	int JDO_COLLECTION = 2;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_COLLECTION__EMPTY = JDO_OBJECT__EMPTY;

	/**
	 * The feature id for the '<em><b>Element Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_COLLECTION__ELEMENT_TYPE = JDO_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Embedded Elemnt</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_COLLECTION__EMBEDDED_ELEMNT = JDO_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Extensions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_COLLECTION__EXTENSIONS = JDO_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the the '<em>JDO Collection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_COLLECTION_FEATURE_COUNT = JDO_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOExtensionImpl <em>JDO Extension</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOExtensionImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOExtension()
	 * @generated
	 */
	int JDO_EXTENSION = 3;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_EXTENSION__EMPTY = JDO_OBJECT__EMPTY;

	/**
	 * The feature id for the '<em><b>Vendor Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_EXTENSION__VENDOR_NAME = JDO_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_EXTENSION__KEY = JDO_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_EXTENSION__VALUE = JDO_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Extensions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_EXTENSION__EXTENSIONS = JDO_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the the '<em>JDO Extension</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_EXTENSION_FEATURE_COUNT = JDO_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOFieldImpl <em>JDO Field</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOFieldImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOField()
	 * @generated
	 */
	int JDO_FIELD = 4;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__EMPTY = JDO_MODEL_ELEMENT__EMPTY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__NAME = JDO_MODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Primary Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__PRIMARY_KEY = JDO_MODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Default Fetch Group</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__DEFAULT_FETCH_GROUP = JDO_MODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Embedded</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__EMBEDDED = JDO_MODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Persistence Modifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__PERSISTENCE_MODIFIER = JDO_MODEL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Null Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__NULL_VALUE = JDO_MODEL_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Extensions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__EXTENSIONS = JDO_MODEL_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Array</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__ARRAY = JDO_MODEL_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Collection</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__COLLECTION = JDO_MODEL_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Map</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD__MAP = JDO_MODEL_ELEMENT_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the the '<em>JDO Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FIELD_FEATURE_COUNT = JDO_MODEL_ELEMENT_FEATURE_COUNT + 9;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.EPackageImpl <em>EPackage</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.EPackageImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getEPackage()
	 * @generated
	 */
	int EPACKAGE = 10;

	/**
	 * The number of structural features of the the '<em>EPackage</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EPACKAGE_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOFileImpl <em>JDO File</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOFileImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOFile()
	 * @generated
	 */
	int JDO_FILE = 5;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FILE__EMPTY = EPACKAGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Packages</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FILE__PACKAGES = EPACKAGE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Extensions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FILE__EXTENSIONS = EPACKAGE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the the '<em>JDO File</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_FILE_FEATURE_COUNT = EPACKAGE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOMapImpl <em>JDO Map</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOMapImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOMap()
	 * @generated
	 */
	int JDO_MAP = 6;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MAP__EMPTY = JDO_OBJECT__EMPTY;

	/**
	 * The feature id for the '<em><b>Key Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MAP__KEY_TYPE = JDO_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Embedded Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MAP__EMBEDDED_KEY = JDO_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Value Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MAP__VALUE_TYPE = JDO_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Embedded Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MAP__EMBEDDED_VALUE = JDO_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Extensions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MAP__EXTENSIONS = JDO_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the the '<em>JDO Map</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_MAP_FEATURE_COUNT = JDO_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.impl.JDOPackageImpl <em>JDO Package</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.impl.JDOPackageImpl
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOPackage()
	 * @generated
	 */
	int JDO_PACKAGE = 9;

	/**
	 * The feature id for the '<em><b>Empty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_PACKAGE__EMPTY = JDO_MODEL_ELEMENT__EMPTY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_PACKAGE__NAME = JDO_MODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Classes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_PACKAGE__CLASSES = JDO_MODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Extensions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_PACKAGE__EXTENSIONS = JDO_MODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>JDO Package</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JDO_PACKAGE_FEATURE_COUNT = JDO_MODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.JDOBoolean <em>JDO Boolean</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.JDOBoolean
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOBoolean()
	 * @generated
	 */
	int JDO_BOOLEAN = 11;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.JDOCompilant <em>JDO Compilant</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.JDOCompilant
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOCompilant()
	 * @generated
	 */
	int JDO_COMPILANT = 12;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.JDOIdentityType <em>JDO Identity Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.JDOIdentityType
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOIdentityType()
	 * @generated
	 */
	int JDO_IDENTITY_TYPE = 13;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.JDONullValue <em>JDO Null Value</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.JDONullValue
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDONullValue()
	 * @generated
	 */
	int JDO_NULL_VALUE = 14;

	/**
	 * The meta object id for the '{@link EclipseSpeedo.metadata.JDOPersistenceModifier <em>JDO Persistence Modifier</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see EclipseSpeedo.metadata.JDOPersistenceModifier
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getJDOPersistenceModifier()
	 * @generated
	 */
	int JDO_PERSISTENCE_MODIFIER = 15;

	/**
	 * The meta object id for the '<em>EList</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.EList
	 * @see EclipseSpeedo.metadata.impl.MetadataPackageImpl#getEList()
	 * @generated
	 */
	int ELIST = 16;


	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOArray <em>JDO Array</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Array</em>'.
	 * @see EclipseSpeedo.metadata.JDOArray
	 * @generated
	 */
	EClass getJDOArray();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOArray#getEmbeddedElement <em>Embedded Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Embedded Element</em>'.
	 * @see EclipseSpeedo.metadata.JDOArray#getEmbeddedElement()
	 * @see #getJDOArray()
	 * @generated
	 */
	EAttribute getJDOArray_EmbeddedElement();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOArray#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extensions</em>'.
	 * @see EclipseSpeedo.metadata.JDOArray#getExtensions()
	 * @see #getJDOArray()
	 * @generated
	 */
	EReference getJDOArray_Extensions();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOClass <em>JDO Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Class</em>'.
	 * @see EclipseSpeedo.metadata.JDOClass
	 * @generated
	 */
	EClass getJDOClass();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOClass#getObjectIdClass <em>Object Id Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Object Id Class</em>'.
	 * @see EclipseSpeedo.metadata.JDOClass#getObjectIdClass()
	 * @see #getJDOClass()
	 * @generated
	 */
	EAttribute getJDOClass_ObjectIdClass();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOClass#isRequiresExtent <em>Requires Extent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Requires Extent</em>'.
	 * @see EclipseSpeedo.metadata.JDOClass#isRequiresExtent()
	 * @see #getJDOClass()
	 * @generated
	 */
	EAttribute getJDOClass_RequiresExtent();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOClass#getPersistenceCapableSuperclass <em>Persistence Capable Superclass</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Persistence Capable Superclass</em>'.
	 * @see EclipseSpeedo.metadata.JDOClass#getPersistenceCapableSuperclass()
	 * @see #getJDOClass()
	 * @generated
	 */
	EAttribute getJDOClass_PersistenceCapableSuperclass();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOClass#getIdentityType <em>Identity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Identity Type</em>'.
	 * @see EclipseSpeedo.metadata.JDOClass#getIdentityType()
	 * @see #getJDOClass()
	 * @generated
	 */
	EAttribute getJDOClass_IdentityType();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOClass#getFields <em>Fields</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Fields</em>'.
	 * @see EclipseSpeedo.metadata.JDOClass#getFields()
	 * @see #getJDOClass()
	 * @generated
	 */
	EReference getJDOClass_Fields();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOClass#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extensions</em>'.
	 * @see EclipseSpeedo.metadata.JDOClass#getExtensions()
	 * @see #getJDOClass()
	 * @generated
	 */
	EReference getJDOClass_Extensions();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOCollection <em>JDO Collection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Collection</em>'.
	 * @see EclipseSpeedo.metadata.JDOCollection
	 * @generated
	 */
	EClass getJDOCollection();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOCollection#getElementType <em>Element Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Element Type</em>'.
	 * @see EclipseSpeedo.metadata.JDOCollection#getElementType()
	 * @see #getJDOCollection()
	 * @generated
	 */
	EAttribute getJDOCollection_ElementType();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOCollection#getEmbeddedElemnt <em>Embedded Elemnt</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Embedded Elemnt</em>'.
	 * @see EclipseSpeedo.metadata.JDOCollection#getEmbeddedElemnt()
	 * @see #getJDOCollection()
	 * @generated
	 */
	EAttribute getJDOCollection_EmbeddedElemnt();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOCollection#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extensions</em>'.
	 * @see EclipseSpeedo.metadata.JDOCollection#getExtensions()
	 * @see #getJDOCollection()
	 * @generated
	 */
	EReference getJDOCollection_Extensions();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOExtension <em>JDO Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Extension</em>'.
	 * @see EclipseSpeedo.metadata.JDOExtension
	 * @generated
	 */
	EClass getJDOExtension();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOExtension#getVendorName <em>Vendor Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Vendor Name</em>'.
	 * @see EclipseSpeedo.metadata.JDOExtension#getVendorName()
	 * @see #getJDOExtension()
	 * @generated
	 */
	EAttribute getJDOExtension_VendorName();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOExtension#getKey <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see EclipseSpeedo.metadata.JDOExtension#getKey()
	 * @see #getJDOExtension()
	 * @generated
	 */
	EAttribute getJDOExtension_Key();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOExtension#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see EclipseSpeedo.metadata.JDOExtension#getValue()
	 * @see #getJDOExtension()
	 * @generated
	 */
	EAttribute getJDOExtension_Value();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOExtension#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extensions</em>'.
	 * @see EclipseSpeedo.metadata.JDOExtension#getExtensions()
	 * @see #getJDOExtension()
	 * @generated
	 */
	EReference getJDOExtension_Extensions();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOField <em>JDO Field</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Field</em>'.
	 * @see EclipseSpeedo.metadata.JDOField
	 * @generated
	 */
	EClass getJDOField();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOField#isPrimaryKey <em>Primary Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Primary Key</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#isPrimaryKey()
	 * @see #getJDOField()
	 * @generated
	 */
	EAttribute getJDOField_PrimaryKey();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOField#getDefaultFetchGroup <em>Default Fetch Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Default Fetch Group</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#getDefaultFetchGroup()
	 * @see #getJDOField()
	 * @generated
	 */
	EAttribute getJDOField_DefaultFetchGroup();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOField#getEmbedded <em>Embedded</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Embedded</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#getEmbedded()
	 * @see #getJDOField()
	 * @generated
	 */
	EAttribute getJDOField_Embedded();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOField#getPersistenceModifier <em>Persistence Modifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Persistence Modifier</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#getPersistenceModifier()
	 * @see #getJDOField()
	 * @generated
	 */
	EAttribute getJDOField_PersistenceModifier();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOField#getNullValue <em>Null Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Null Value</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#getNullValue()
	 * @see #getJDOField()
	 * @generated
	 */
	EAttribute getJDOField_NullValue();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOField#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extensions</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#getExtensions()
	 * @see #getJDOField()
	 * @generated
	 */
	EReference getJDOField_Extensions();

	/**
	 * Returns the meta object for the containment reference '{@link EclipseSpeedo.metadata.JDOField#getArray <em>Array</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Array</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#getArray()
	 * @see #getJDOField()
	 * @generated
	 */
	EReference getJDOField_Array();

	/**
	 * Returns the meta object for the containment reference '{@link EclipseSpeedo.metadata.JDOField#getCollection <em>Collection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Collection</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#getCollection()
	 * @see #getJDOField()
	 * @generated
	 */
	EReference getJDOField_Collection();

	/**
	 * Returns the meta object for the containment reference '{@link EclipseSpeedo.metadata.JDOField#getMap <em>Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Map</em>'.
	 * @see EclipseSpeedo.metadata.JDOField#getMap()
	 * @see #getJDOField()
	 * @generated
	 */
	EReference getJDOField_Map();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOFile <em>JDO File</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO File</em>'.
	 * @see EclipseSpeedo.metadata.JDOFile
	 * @generated
	 */
	EClass getJDOFile();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOFile#isEmpty <em>Empty</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Empty</em>'.
	 * @see EclipseSpeedo.metadata.JDOFile#isEmpty()
	 * @see #getJDOFile()
	 * @generated
	 */
	EAttribute getJDOFile_Empty();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOFile#getPackages <em>Packages</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Packages</em>'.
	 * @see EclipseSpeedo.metadata.JDOFile#getPackages()
	 * @see #getJDOFile()
	 * @generated
	 */
	EReference getJDOFile_Packages();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOFile#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extensions</em>'.
	 * @see EclipseSpeedo.metadata.JDOFile#getExtensions()
	 * @see #getJDOFile()
	 * @generated
	 */
	EReference getJDOFile_Extensions();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOMap <em>JDO Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Map</em>'.
	 * @see EclipseSpeedo.metadata.JDOMap
	 * @generated
	 */
	EClass getJDOMap();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOMap#getKeyType <em>Key Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key Type</em>'.
	 * @see EclipseSpeedo.metadata.JDOMap#getKeyType()
	 * @see #getJDOMap()
	 * @generated
	 */
	EAttribute getJDOMap_KeyType();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOMap#getEmbeddedKey <em>Embedded Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Embedded Key</em>'.
	 * @see EclipseSpeedo.metadata.JDOMap#getEmbeddedKey()
	 * @see #getJDOMap()
	 * @generated
	 */
	EAttribute getJDOMap_EmbeddedKey();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOMap#getValueType <em>Value Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value Type</em>'.
	 * @see EclipseSpeedo.metadata.JDOMap#getValueType()
	 * @see #getJDOMap()
	 * @generated
	 */
	EAttribute getJDOMap_ValueType();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOMap#getEmbeddedValue <em>Embedded Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Embedded Value</em>'.
	 * @see EclipseSpeedo.metadata.JDOMap#getEmbeddedValue()
	 * @see #getJDOMap()
	 * @generated
	 */
	EAttribute getJDOMap_EmbeddedValue();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOMap#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extensions</em>'.
	 * @see EclipseSpeedo.metadata.JDOMap#getExtensions()
	 * @see #getJDOMap()
	 * @generated
	 */
	EReference getJDOMap_Extensions();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOModelElement <em>JDO Model Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Model Element</em>'.
	 * @see EclipseSpeedo.metadata.JDOModelElement
	 * @generated
	 */
	EClass getJDOModelElement();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOModelElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see EclipseSpeedo.metadata.JDOModelElement#getName()
	 * @see #getJDOModelElement()
	 * @generated
	 */
	EAttribute getJDOModelElement_Name();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOObject <em>JDO Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Object</em>'.
	 * @see EclipseSpeedo.metadata.JDOObject
	 * @generated
	 */
	EClass getJDOObject();

	/**
	 * Returns the meta object for the attribute '{@link EclipseSpeedo.metadata.JDOObject#isEmpty <em>Empty</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Empty</em>'.
	 * @see EclipseSpeedo.metadata.JDOObject#isEmpty()
	 * @see #getJDOObject()
	 * @generated
	 */
	EAttribute getJDOObject_Empty();

	/**
	 * Returns the meta object for class '{@link EclipseSpeedo.metadata.JDOPackage <em>JDO Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>JDO Package</em>'.
	 * @see EclipseSpeedo.metadata.JDOPackage
	 * @generated
	 */
	EClass getJDOPackage();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOPackage#getClasses <em>Classes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Classes</em>'.
	 * @see EclipseSpeedo.metadata.JDOPackage#getClasses()
	 * @see #getJDOPackage()
	 * @generated
	 */
	EReference getJDOPackage_Classes();

	/**
	 * Returns the meta object for the containment reference list '{@link EclipseSpeedo.metadata.JDOPackage#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extensions</em>'.
	 * @see EclipseSpeedo.metadata.JDOPackage#getExtensions()
	 * @see #getJDOPackage()
	 * @generated
	 */
	EReference getJDOPackage_Extensions();

	/**
	 * Returns the meta object for class '{@link org.eclipse.emf.ecore.EPackage <em>EPackage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>EPackage</em>'.
	 * @see org.eclipse.emf.ecore.EPackage
	 * @model instanceClass="org.eclipse.emf.ecore.EPackage" 
	 * @generated
	 */
	EClass getEPackage();

	/**
	 * Returns the meta object for enum '{@link EclipseSpeedo.metadata.JDOBoolean <em>JDO Boolean</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>JDO Boolean</em>'.
	 * @see EclipseSpeedo.metadata.JDOBoolean
	 * @generated
	 */
	EEnum getJDOBoolean();

	/**
	 * Returns the meta object for enum '{@link EclipseSpeedo.metadata.JDOCompilant <em>JDO Compilant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>JDO Compilant</em>'.
	 * @see EclipseSpeedo.metadata.JDOCompilant
	 * @generated
	 */
	EEnum getJDOCompilant();

	/**
	 * Returns the meta object for enum '{@link EclipseSpeedo.metadata.JDOIdentityType <em>JDO Identity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>JDO Identity Type</em>'.
	 * @see EclipseSpeedo.metadata.JDOIdentityType
	 * @generated
	 */
	EEnum getJDOIdentityType();

	/**
	 * Returns the meta object for enum '{@link EclipseSpeedo.metadata.JDONullValue <em>JDO Null Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>JDO Null Value</em>'.
	 * @see EclipseSpeedo.metadata.JDONullValue
	 * @generated
	 */
	EEnum getJDONullValue();

	/**
	 * Returns the meta object for enum '{@link EclipseSpeedo.metadata.JDOPersistenceModifier <em>JDO Persistence Modifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>JDO Persistence Modifier</em>'.
	 * @see EclipseSpeedo.metadata.JDOPersistenceModifier
	 * @generated
	 */
	EEnum getJDOPersistenceModifier();

	/**
	 * Returns the meta object for data type '{@link org.eclipse.emf.common.util.EList <em>EList</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>EList</em>'.
	 * @see org.eclipse.emf.common.util.EList
	 * @model instanceClass="org.eclipse.emf.common.util.EList"
	 * @generated
	 */
	EDataType getEList();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MetadataFactory getMetadataFactory();

} //MetadataPackage
