/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.objectweb.eclipsespeedo.metadata.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.objectweb.eclipsespeedo.metadata.JDOExtension;
import org.objectweb.eclipsespeedo.metadata.JDOFile;
import org.objectweb.eclipsespeedo.metadata.JDOPackage;
import org.objectweb.eclipsespeedo.metadata.MetadataPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>JDO File</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link EclipseSpeedo.metadata.impl.JDOFileImpl#isEmpty <em>Empty</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.impl.JDOFileImpl#getPackages <em>Packages</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.impl.JDOFileImpl#getExtensions <em>Extensions</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JDOFileImpl extends EPackageImpl implements JDOFile {
	/**
	 * The default value of the '{@link #isEmpty() <em>Empty</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEmpty()
	 * @generated
	 * @ordered
	 */
	protected static final boolean EMPTY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isEmpty() <em>Empty</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEmpty()
	 * @generated
	 * @ordered
	 */
	protected boolean empty = EMPTY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPackages() <em>Packages</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPackages()
	 * @generated
	 * @ordered
	 */
	protected EList packages = null;

	/**
	 * The cached value of the '{@link #getExtensions() <em>Extensions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExtensions()
	 * @generated
	 * @ordered
	 */
	protected EList extensions = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected JDOFileImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return MetadataPackage.eINSTANCE.getJDOFile();
	}

	/**
	 */
	public boolean isEmpty() {
		if (packages != null)
		{
			Iterator iterator = packages.iterator();
			while (iterator.hasNext())
			{
				JDOPackage jdoPackage = (JDOPackage) iterator.next();
				if (!jdoPackage.isEmpty())
				{
					return false;
				}
			}
		}

		return true;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public void shrink() {
		if (packages != null)
		{
			Iterator iterator = (new ArrayList(packages)).iterator();
			while (iterator.hasNext())
			{
				JDOPackage jdoPackage = (JDOPackage) iterator.next();
				if (jdoPackage.isEmpty())
				{
					packages.remove(jdoPackage);
				}
			}
			if (packages.isEmpty())
			{
				packages = null;
			}
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEmpty(boolean newEmpty) {
		boolean oldEmpty = empty;
		empty = newEmpty;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MetadataPackage.JDO_FILE__EMPTY, oldEmpty, empty));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getPackages() {
		if (packages == null) {
			packages = new EObjectContainmentEList(JDOPackage.class, this, MetadataPackage.JDO_FILE__PACKAGES);
		}
		return packages;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getExtensions() {
		if (extensions == null) {
			extensions = new EObjectContainmentEList(JDOExtension.class, this, MetadataPackage.JDO_FILE__EXTENSIONS);
		}
		return extensions;
	}



	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOPackage findPackage(String packageName) {
		if (packageName != null && packages != null) {
			Iterator iterator = packages.iterator();
			while (iterator.hasNext()) {
				JDOPackage jdoPackage = (JDOPackage) iterator.next();
				if (packageName.equals(jdoPackage.getName())) {
					return jdoPackage;
				}
			}
		}

		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case MetadataPackage.JDO_FILE__PACKAGES:
					return ((InternalEList)getPackages()).basicRemove(otherEnd, msgs);
				case MetadataPackage.JDO_FILE__EXTENSIONS:
					return ((InternalEList)getExtensions()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.JDO_FILE__EMPTY:
				return isEmpty() ? Boolean.TRUE : Boolean.FALSE;
			case MetadataPackage.JDO_FILE__PACKAGES:
				return getPackages();
			case MetadataPackage.JDO_FILE__EXTENSIONS:
				return getExtensions();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.JDO_FILE__EMPTY:
				setEmpty(((Boolean)newValue).booleanValue());
				return;
			case MetadataPackage.JDO_FILE__PACKAGES:
				getPackages().clear();
				getPackages().addAll((Collection)newValue);
				return;
			case MetadataPackage.JDO_FILE__EXTENSIONS:
				getExtensions().clear();
				getExtensions().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.JDO_FILE__EMPTY:
				setEmpty(EMPTY_EDEFAULT);
				return;
			case MetadataPackage.JDO_FILE__PACKAGES:
				getPackages().clear();
				return;
			case MetadataPackage.JDO_FILE__EXTENSIONS:
				getExtensions().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.JDO_FILE__EMPTY:
				return empty != EMPTY_EDEFAULT;
			case MetadataPackage.JDO_FILE__PACKAGES:
				return packages != null && !packages.isEmpty();
			case MetadataPackage.JDO_FILE__EXTENSIONS:
				return extensions != null && !extensions.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (empty: ");
		result.append(empty);
		result.append(')');
		return result.toString();
	}

} //JDOFileImpl
