/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.objectweb.eclipsespeedo.metadata.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.objectweb.eclipsespeedo.metadata.JDOClass;
import org.objectweb.eclipsespeedo.metadata.JDOExtension;
import org.objectweb.eclipsespeedo.metadata.JDOPackage;
import org.objectweb.eclipsespeedo.metadata.MetadataPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>JDO Package</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link EclipseSpeedo.metadata.impl.JDOPackageImpl#getClasses <em>Classes</em>}</li>
 *   <li>{@link EclipseSpeedo.metadata.impl.JDOPackageImpl#getExtensions <em>Extensions</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class JDOPackageImpl extends JDOModelElementImpl implements JDOPackage {
	/**
	 * The cached value of the '{@link #getClasses() <em>Classes</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClasses()
	 * @generated
	 * @ordered
	 */
	protected EList classes = null;

	/**
	 * The cached value of the '{@link #getExtensions() <em>Extensions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExtensions()
	 * @generated
	 * @ordered
	 */
	protected EList extensions = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected JDOPackageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return MetadataPackage.eINSTANCE.getJDOPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getClasses() {
		if (classes == null) {
			classes = new EObjectContainmentEList(JDOClass.class, this, MetadataPackage.JDO_PACKAGE__CLASSES);
		}
		return classes;
	}
	
	
	/**
	 */
	public boolean isEmpty() {
		if (classes != null){
			if (!classes.isEmpty()) {
				return false;
			}
		}

		return super.isEmpty();
	}
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getExtensions() {
		if (extensions == null) {
			extensions = new EObjectContainmentEList(JDOExtension.class, this, MetadataPackage.JDO_PACKAGE__EXTENSIONS);
		}
		return extensions;
	}
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public void shrink()
	{
		if (classes != null)		{
			Iterator iterator = (new ArrayList(classes)).iterator();
			while (iterator.hasNext()) {
				JDOClass jdoClass = (JDOClass) iterator.next();
				jdoClass.shrink();
			}
			if (classes.isEmpty()){
				classes = null;
			}
		}

		super.shrink();
	}
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOClass findClass(String className) {
		if (className != null && classes != null)	{
			Iterator iterator = classes.iterator();
			while (iterator.hasNext()) {
				JDOClass jdoClass = (JDOClass) iterator.next();
				if (className.equals(jdoClass.getName())) {
					return jdoClass;
				}
			}
		}

		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case MetadataPackage.JDO_PACKAGE__CLASSES:
					return ((InternalEList)getClasses()).basicRemove(otherEnd, msgs);
				case MetadataPackage.JDO_PACKAGE__EXTENSIONS:
					return ((InternalEList)getExtensions()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.JDO_PACKAGE__EMPTY:
				return isEmpty() ? Boolean.TRUE : Boolean.FALSE;
			case MetadataPackage.JDO_PACKAGE__NAME:
				return getName();
			case MetadataPackage.JDO_PACKAGE__CLASSES:
				return getClasses();
			case MetadataPackage.JDO_PACKAGE__EXTENSIONS:
				return getExtensions();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.JDO_PACKAGE__EMPTY:
				setEmpty(((Boolean)newValue).booleanValue());
				return;
			case MetadataPackage.JDO_PACKAGE__NAME:
				setName((String)newValue);
				return;
			case MetadataPackage.JDO_PACKAGE__CLASSES:
				getClasses().clear();
				getClasses().addAll((Collection)newValue);
				return;
			case MetadataPackage.JDO_PACKAGE__EXTENSIONS:
				getExtensions().clear();
				getExtensions().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.JDO_PACKAGE__EMPTY:
				setEmpty(EMPTY_EDEFAULT);
				return;
			case MetadataPackage.JDO_PACKAGE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MetadataPackage.JDO_PACKAGE__CLASSES:
				getClasses().clear();
				return;
			case MetadataPackage.JDO_PACKAGE__EXTENSIONS:
				getExtensions().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.JDO_PACKAGE__EMPTY:
				return empty != EMPTY_EDEFAULT;
			case MetadataPackage.JDO_PACKAGE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MetadataPackage.JDO_PACKAGE__CLASSES:
				return classes != null && !classes.isEmpty();
			case MetadataPackage.JDO_PACKAGE__EXTENSIONS:
				return extensions != null && !extensions.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} //JDOPackageImpl
