/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.objectweb.eclipsespeedo.metadata.impl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.objectweb.eclipsespeedo.metadata.JDOArray;
import org.objectweb.eclipsespeedo.metadata.JDOBoolean;
import org.objectweb.eclipsespeedo.metadata.JDOClass;
import org.objectweb.eclipsespeedo.metadata.JDOCollection;
import org.objectweb.eclipsespeedo.metadata.JDOCompilant;
import org.objectweb.eclipsespeedo.metadata.JDOExtension;
import org.objectweb.eclipsespeedo.metadata.JDOField;
import org.objectweb.eclipsespeedo.metadata.JDOFile;
import org.objectweb.eclipsespeedo.metadata.JDOIdentityType;
import org.objectweb.eclipsespeedo.metadata.JDOMap;
import org.objectweb.eclipsespeedo.metadata.JDONullValue;
import org.objectweb.eclipsespeedo.metadata.JDOPackage;
import org.objectweb.eclipsespeedo.metadata.JDOPersistenceModifier;
import org.objectweb.eclipsespeedo.metadata.MetadataFactory;
import org.objectweb.eclipsespeedo.metadata.MetadataPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MetadataFactoryImpl extends EFactoryImpl implements MetadataFactory {
	/**
	 * Creates and instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetadataFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case MetadataPackage.JDO_ARRAY: return createJDOArray();
			case MetadataPackage.JDO_CLASS: return createJDOClass();
			case MetadataPackage.JDO_COLLECTION: return createJDOCollection();
			case MetadataPackage.JDO_EXTENSION: return createJDOExtension();
			case MetadataPackage.JDO_FIELD: return createJDOField();
			case MetadataPackage.JDO_FILE: return createJDOFile();
			case MetadataPackage.JDO_MAP: return createJDOMap();
			case MetadataPackage.JDO_PACKAGE: return createJDOPackage();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case MetadataPackage.JDO_BOOLEAN:
				return JDOBoolean.get(initialValue);
			case MetadataPackage.JDO_COMPILANT:
				return JDOCompilant.get(initialValue);
			case MetadataPackage.JDO_IDENTITY_TYPE:
				return JDOIdentityType.get(initialValue);
			case MetadataPackage.JDO_NULL_VALUE:
				return JDONullValue.get(initialValue);
			case MetadataPackage.JDO_PERSISTENCE_MODIFIER:
				return JDOPersistenceModifier.get(initialValue);
			case MetadataPackage.ELIST:
				return createEListFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case MetadataPackage.JDO_BOOLEAN:
				return instanceValue == null ? null : instanceValue.toString();
			case MetadataPackage.JDO_COMPILANT:
				return instanceValue == null ? null : instanceValue.toString();
			case MetadataPackage.JDO_IDENTITY_TYPE:
				return instanceValue == null ? null : instanceValue.toString();
			case MetadataPackage.JDO_NULL_VALUE:
				return instanceValue == null ? null : instanceValue.toString();
			case MetadataPackage.JDO_PERSISTENCE_MODIFIER:
				return instanceValue == null ? null : instanceValue.toString();
			case MetadataPackage.ELIST:
				return convertEListToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOArray createJDOArray() {
		JDOArrayImpl jdoArray = new JDOArrayImpl();
		return jdoArray;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOClass createJDOClass() {
		JDOClassImpl jdoClass = new JDOClassImpl();
		return jdoClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOCollection createJDOCollection() {
		JDOCollectionImpl jdoCollection = new JDOCollectionImpl();
		return jdoCollection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOExtension createJDOExtension() {
		JDOExtensionImpl jdoExtension = new JDOExtensionImpl();
		return jdoExtension;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOField createJDOField() {
		JDOFieldImpl jdoField = new JDOFieldImpl();
		return jdoField;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOFile createJDOFile() {
		JDOFileImpl jdoFile = new JDOFileImpl();
		return jdoFile;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOMap createJDOMap() {
		JDOMapImpl jdoMap = new JDOMapImpl();
		return jdoMap;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public JDOPackage createJDOPackage() {
		JDOPackageImpl jdoPackage = new JDOPackageImpl();
		return jdoPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList createEListFromString(EDataType eDataType, String initialValue) {
		return (EList)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertEListToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetadataPackage getMetadataPackage() {
		return (MetadataPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static MetadataPackage getPackage() {
		return MetadataPackage.eINSTANCE;
	}

} //MetadataFactoryImpl
