package org.objectweb.eclipsespeedo.ui;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.IType;


class ClassScopeValider implements IResourceScopeValider
{
	IJavaElement parent;
	IJavaElement root;

	/**
	 * 
	 */
	public ClassScopeValider(IJavaElement parent, IJavaElement root)
	{
		this.parent = parent;
		this.root = root;
	}

	public boolean isValid(IJavaElement child)
	{
		if (child.getElementType() == IJavaElement.TYPE)
		{
			IType type = (IType) child;
			IPackageFragment packageFragment = type.getPackageFragment();
			if (parent.equals(packageFragment))
			{
				return root.equals(type);
			}
		}
		return true;
	}

}
