
package org.objectweb.eclipsespeedo.ui;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eclipse.core.resources.IStorage;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IPersistableElement;
import org.eclipse.ui.IStorageEditorInput;


class MemoryEditorInput implements IStorageEditorInput
{
	String content;
	/**
	 * 
	 */
	public MemoryEditorInput(String content)
	{
		this.content = content;
	}

	public class MemoryStorage implements IStorage
	{
		/**
		 * @see IStorage#getContents()
		 */
		public InputStream getContents() throws CoreException
		{
			return new ByteArrayInputStream(content.getBytes());
		}

		/**
		 * @see IStorage#getFullPath()
		 */
		public IPath getFullPath()
		{
			return null;
		}

		/**
		 * @see IStorage#getName()
		 */
		public String getName()
		{
			return "Empty";
		}

		/**
		 * @see IStorage#isReadOnly()
		 */
		public boolean isReadOnly()
		{
			return true;
		}

		/**
		 * @see IAdaptable#getAdapter(Class)
		 */
		public Object getAdapter(Class adapter)
		{
			return null;
		}

	}
	/**
	 * @see IStorageEditorInput#getStorage()
	 */
	public IStorage getStorage() throws CoreException
	{
		return new MemoryStorage();
	}

	/**
	 * @see IEditorInput#exists()
	 */
	public boolean exists()
	{
		return false;
	}

	/**
	 * @see IEditorInput#getImageDescriptor()
	 */
	public ImageDescriptor getImageDescriptor()
	{
		return null;
	}

	/**
	 * @see IEditorInput#getName()
	 */
	public String getName()
	{
		return "Null EditorInput";
	}

	/**
	 * @see IEditorInput#getPersistable()
	 */
	public IPersistableElement getPersistable()
	{
		return null;
	}

	/**
	 * @see IEditorInput#getToolTipText()
	 */
	public String getToolTipText()
	{
		return null;
	}

	/**
	 * @see IAdaptable#getAdapter(Class)
	 */
	public Object getAdapter(Class adapter)
	{
		return null;
	}

}
