
package org.objectweb.eclipsespeedo.ui;

import org.eclipse.jdt.core.IField;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.IType;


class PackageScopeValider implements IResourceScopeValider
{
	IPackageFragment root;

	/**
	 * 
	 */
	public PackageScopeValider(IPackageFragment root)
	{
		this.root = root;
	}

	
	public boolean isValid(IJavaElement child)
	{
		if (child.equals(root))
		{
			return true;
		}
		if (child.getElementType() == IJavaElement.TYPE)
		{
			IType type = (IType) child;
			IPackageFragment packageFragment = type.getPackageFragment();
			if (root.equals(packageFragment))
			{
				return true;
			}
		}
		switch (child.getElementType())
		{
			case IJavaElement.FIELD :
				{
					IField field = (IField) child;
					return isValid(field.getParent());
				}
			case IJavaElement.TYPE :
				{
					IType type = (IType) child;
					IPackageFragment packageFragment =
						type.getPackageFragment();
					if (root.equals(packageFragment))
					{
						return true;
					}
				}
				break;
		}
		return false;
	}
}
