/*
 * Created on May 11, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */
package org.objectweb.eclipsespeedo.ui;


import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.StringTokenizer;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.core.IClasspathEntry;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseTrackListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbenchPropertyPage;
import org.eclipse.ui.dialogs.ContainerSelectionDialog;
import org.eclipse.ui.dialogs.PropertyPage;
import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.eclipsespeedo.drivers.xml.ClasspathItem;
import org.objectweb.eclipsespeedo.drivers.xml.DriverDefinition;
import org.objectweb.eclipsespeedo.drivers.xml.DriverDefinitionProperty;
import org.objectweb.eclipsespeedo.drivers.xml.JDOProjectConfGroup;
import org.objectweb.eclipsespeedo.project.ProjectProperties;
import org.objectweb.eclipsespeedo.utils.PropertiesFileGen;
import org.objectweb.util.monolog.api.Logger;

/**
 * @author vezieran
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ProjectPropertyPage extends PropertyPage implements IWorkbenchPropertyPage, SelectionListener {


	private Logger logger = EclipseSpeedoPlugin.loggerFactory.getLogger(ProjectPropertyPage.class.getName());
	private IJavaProject curproject;
	private Combo fDriverCombo;
	private Composite content;
	private Composite selectionBar;
	private ArrayList definitions;
	private int selectedDriverIndex;
	private Composite body;
	private ArrayList selectedControls;
	private ArrayList newpclasspath;
	private ArrayList oldpclasspath;
	private Text descText;
	private String[] grpdesc;
	private int curgrp = 0;
	private TabFolder tabF;
	
	protected Control createContents(Composite parent) {
		
		this.curproject = JavaCore.create((IProject) this.getElement());
		EclipseSpeedoPlugin.getDefault().getDriverDefinitionManager().refresh();
		definitions = EclipseSpeedoPlugin.getDefault().getDriverDefinitionManager().getDefinitions();
		
		try {
			String driver = ProjectProperties.getProjectProperty(curproject.getProject(), "Driver");
			Iterator defs = definitions.iterator();
			while (defs.hasNext()) {
				DriverDefinition element = (DriverDefinition) defs.next();
				if (driver.equals(element.getName())) {
					selectedDriverIndex = definitions.indexOf(element);
					oldpclasspath = new ArrayList();
					newpclasspath = new ArrayList();
					for (Iterator ite = element.getEclipseprefconf().getProjClasspath().iterator(); ite.hasNext();){
						newpclasspath.add(((ClasspathItem) ite.next()).getClasspath());
					}
					StringTokenizer st = new StringTokenizer(ProjectProperties.getProjectProperty(curproject.getProject(), "oldPCP"));
					while (st.hasMoreTokens()) {
						oldpclasspath.add(st.nextToken());
					}
					break;
				}

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		selectedControls = new ArrayList();		
		this.content = createContainer(parent);
		createSelectionBar();
		createBody();
		
		Group DescView = new Group(createContainer(parent), SWT.NONE | SWT.CENTER);
		DescView.setText("Description");
		GridLayout layout = new GridLayout();
		layout.numColumns = 1;

		layout.makeColumnsEqualWidth = false;
		DescView.setLayout(layout);
		GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
		DescView.setLayoutData(gridData);
		gridData = new GridData(GridData.FILL_HORIZONTAL |GridData.GRAB_HORIZONTAL );
		gridData.widthHint = 600;
		gridData.heightHint = 100;
		this.descText = new Text(DescView, SWT.BORDER | SWT.READ_ONLY |SWT.WRAP );
		this.descText.setLayoutData(gridData);
		descText.setText(grpdesc[0]);
		return content;
	}




	protected Composite createContainer(Composite parent) {
		Composite container = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.numColumns = 1;
		layout.makeColumnsEqualWidth = false;
		container.setLayout(layout);
		GridData gridData =
			new GridData(
				GridData.FILL_BOTH
					| GridData.GRAB_VERTICAL
					| GridData.GRAB_HORIZONTAL);
		return container;
	}

	private void createSelectionBar() {
		selectionBar = new Group(content, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.numColumns = 2;
		layout.makeColumnsEqualWidth = false;
		selectionBar.setLayout(layout);
		GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
		selectionBar.setLayoutData(gridData);
		// Project name
		Label pnamel = new Label(selectionBar,SWT.NONE);
		pnamel.setText(EclipseSpeedoPlugin.getResourceString("prop_driverpage_projectname"));
		Text pnamet = new Text(selectionBar, SWT.BORDER | SWT.READ_ONLY);
		pnamet.setSize(300,10);
		pnamet.setText(curproject.getProject().getName());
		Label label = new Label(selectionBar, SWT.NONE);
		label.setText("Choose your JDO Driver for this project: ");
		gridData = new GridData();
		label.setLayoutData(gridData);
		fDriverCombo = new Combo(selectionBar, SWT.BORDER);
		Iterator defs = definitions.iterator();
		while (defs.hasNext()) {
			DriverDefinition element = (DriverDefinition) defs.next();
			fDriverCombo.add(element.getName());
		}
		gridData = new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL);
		fDriverCombo.setLayoutData(gridData);
		fDriverCombo.select(selectedDriverIndex);
		fDriverCombo.addSelectionListener(this);
	}

	private void createBody() {
		
		content.layout(true);
		body = new Composite(content, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.numColumns = 1;
		layout.makeColumnsEqualWidth = false;
		body.setLayout(layout);
		GridData gridData =	new GridData(GridData.FILL_BOTH | GridData.GRAB_VERTICAL);
		body.setLayoutData(gridData);

		tabF = new TabFolder(body, SWT.NONE);
		tabF.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.GRAB_VERTICAL));

		DriverDefinition element = (DriverDefinition) definitions.get(selectedDriverIndex);
		grpdesc = new String[element.getJDOprojconf().getGroups().size()];
		int i = 0;
		for (Iterator ite = element.getJDOprojconf().getGroups().iterator();ite.hasNext();) {
			JDOProjectConfGroup curGroup = (JDOProjectConfGroup) ite.next();
			Composite curTab = createTab(curGroup.getName(), "",	tabF);
			grpdesc[i++] = curGroup.getDesc();		
			ProjectPanel projPanel = new ProjectPanel();
			projPanel.createContents(curGroup, element.getName(), curTab);
		}
		tabF.setSelection(0);
		tabF.addMouseListener(new groupSelected(tabF.getSelectionIndex()));
		body.layout(true);
		body.setRedraw(true);
		content.redraw();
	}

	public class groupSelected implements MouseListener{

		int item;

		public groupSelected(int i){
			item = i;
		}

		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.MouseListener#mouseDoubleClick(org.eclipse.swt.events.MouseEvent)
		 */
		public void mouseDoubleClick(MouseEvent e) {
			// TODO Auto-generated method stub
			
		}

		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.MouseListener#mouseDown(org.eclipse.swt.events.MouseEvent)
		 */
		public void mouseDown(MouseEvent e) {
			item = tabF.getSelectionIndex();
			curgrp = item;
			descText.setText(grpdesc[item]);		
		}

		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.MouseListener#mouseUp(org.eclipse.swt.events.MouseEvent)
		 */
		public void mouseUp(MouseEvent e) {
			// TODO Auto-generated method stub
			
		}




	}

	private Composite createTab(
		String tabDesc,
		String toolTip,
		TabFolder tabFolder) {
		TabItem containerTab = new TabItem(tabFolder, SWT.NONE);
		containerTab.setText(tabDesc);


				
		ScrolledComposite scroll = new ScrolledComposite(tabFolder, SWT.H_SCROLL | SWT.V_SCROLL | SWT.SHADOW_ETCHED_IN);

		scroll.setLayout(new GridLayout(1,true));
		scroll.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.GRAB_VERTICAL | GridData.GRAB_HORIZONTAL));
		Composite composite = new Composite(scroll,SWT.NONE);
		scroll.setContent(composite);
		
		
		GridLayout gridLayout = new GridLayout(1,false);
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		composite.setLayout(gridLayout);
		composite.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.GRAB_VERTICAL | GridData.GRAB_HORIZONTAL));
		containerTab.setControl(scroll);
		containerTab.setToolTipText(toolTip);
		return composite;
	}

	/*
	 * @see SelectionListener#widgetSelected(SelectionEvent)
	 */
	public void widgetSelected(SelectionEvent e) {
		try {
			selectedDriverIndex = ((Combo) e.getSource()).getSelectionIndex();
			DriverDefinition def = (DriverDefinition) definitions.get(selectedDriverIndex);
			ProjectProperties.setProjectProperty(curproject.getProject(), def.getName(),"Driver");
			newpclasspath =new ArrayList();
			for (Iterator ite = def.getEclipseprefconf().getProjClasspath().iterator(); ite.hasNext();){
				
				newpclasspath.add(((ClasspathItem) ite.next()).getClasspath());
			}
			selectedControls.clear();
			body.dispose();
			createBody();
			content.layout(true);
			body.setRedraw(true);
			content.redraw();
			body.redraw();
			content.update();
			descText.setText(grpdesc[0]);
		} catch (CoreException e1) {
			e1.printStackTrace();
		}
	}

	public void widgetDefaultSelected(SelectionEvent e) {
		widgetSelected(e);
	}
	
	class ProjectPanel {

		protected Control createContents(JDOProjectConfGroup group, String title, Composite parent) {
			return createProjectDefinitionPanel(group, parent);
		}

		protected Control createProjectDefinitionPanel(
			JDOProjectConfGroup group,
			Composite composite) {
			Group defPanel = new Group(composite, SWT.NONE);
			defPanel.setText(group.getName());
			GridLayout layout = new GridLayout(3, false);
			defPanel.setLayout(layout);
			GridData gridData =
				new GridData(
					GridData.FILL_BOTH
						| GridData.GRAB_VERTICAL
						| GridData.GRAB_HORIZONTAL);
			gridData.widthHint = convertWidthInCharsToPixels(100);

			defPanel.setLayoutData(gridData);
			Iterator properties = group.getProperties().iterator();
			while (properties.hasNext()) {
				DriverDefinitionProperty item =	(DriverDefinitionProperty) properties.next();
				Control control = null;
				switch (item.getType()) {
					case DriverDefinitionProperty.DIRECTORY :
						control = createLabeledPath(item, defPanel);
						break;					
					case DriverDefinitionProperty.FILE :
						control = createLabeledFile(item, defPanel, "*");
						break;
					case DriverDefinitionProperty.STRING :
						control = createLabeledText(item,defPanel);
						break;
					case DriverDefinitionProperty.COMBO :
						control = createLabeledCombo(item, defPanel);
						break;
					case DriverDefinitionProperty.EFOLDER :
						control = createLabeledEFolder(item, defPanel);
						break;
					case DriverDefinitionProperty.PCLASSPATH :
						control = createLabeledFile(item, defPanel, "*.jar");
						break;
					case DriverDefinitionProperty.BOOLEAN :
						control = createLabeledCheck(item, defPanel);
						break;
					default :
						control = createLabeledText(item,defPanel);
						break;

				}
				selectedControls.add(control);
			}
			composite.setSize(composite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
			composite.layout();
			              
			return defPanel;
		}

		/**
		 * @param string
		 * @param string2
		 * @param b
		 * @param defPanel
		 * @return
		 */
		private Control createLabeledEFolder(DriverDefinitionProperty item, Composite defPanel) {
			GridData gridData;
			String title = item.getLabel();
			String value = ProjectProperties.getSelDriverProperty(curproject.getProject(), item.getId());
			Label label = new Label(defPanel, SWT.WRAP);
			gridData = new GridData();
			//gridData.horizontalSpan = 1;
			label.setLayoutData(gridData);
			label.setText(title);
			label.addMouseTrackListener(new MListener(item));
			final Text fText = new Text(defPanel, SWT.SHADOW_IN | SWT.BORDER);
			gridData = new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL);
			gridData.horizontalSpan = 1;
			fText.setLayoutData(gridData);
			fText.setText(value);

			Button chooseInputButton = new Button(defPanel, SWT.NONE);
			chooseInputButton.setText(EclipseSpeedoPlugin.getResourceString("prop_driverpage_folderbutton"));
			chooseInputButton.addListener(SWT.Selection, new Listener()	{
				public void handleEvent(Event e)
				{
					chooseFolder(fText);
				}
			});

			return fText;
		}
		
		/**
		 * Open a dialog box that allow to select an input folder for the current Speedo project
		 *
		 */
		private void chooseFolder(Text t){
			ContainerSelectionDialog dialog = new ContainerSelectionDialog(getShell(),
																		   ((IContainer) getElement()),
																		   false,
																		   EclipseSpeedoPlugin.getResourceString("prop_driverpage_chooseFolderTitle"));
			dialog.open();
			Object[] result = dialog.getResult();
			if (result == null || result.length == 0) return;
			t.setText(EclipseSpeedoPlugin.getWorkspace().getRoot().getLocation()+((Path) result[0]).toString());
		}


		private Control createLabeledCombo(DriverDefinitionProperty item, Group defPanel) {
			GridData gridData;
			String string = item.getLabel();
			String string2 = item.getDefaultValue();
			Label label = new Label(defPanel, SWT.NONE);
			gridData = new GridData();
			label.setLayoutData(gridData);
			label.setText(EclipseSpeedoPlugin.getResourceString(string));
			label.addMouseTrackListener(new MListener(item));
			gridData = new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL);
			gridData.horizontalSpan = 2;
			Combo combo = new Combo(defPanel, SWT.SINGLE | SWT.BORDER | SWT.READ_ONLY);
			combo.setLayoutData(gridData);
			StringTokenizer st = new StringTokenizer(string2);
			while (st.hasMoreTokens()) {
				combo.add((String) st.nextToken());
			}
			String[] items = combo.getItems();
			for (int i = 0;i<items.length;i++){
				if (items[i].equals(ProjectProperties.getSelDriverProperty(curproject.getProject(), item.getId()))){
					combo.select(i);
					break;
				}
			}
			return combo;
		}

		protected Text createLabeledText(
			DriverDefinitionProperty item,
			Composite defPanel) {
			GridData gridData;
			String title = item.getLabel();
			String value = ProjectProperties.getSelDriverProperty(curproject.getProject(), item.getId());
			if (value.equals("")) value = item.getDefaultValue();
			boolean modifiable = item.isModifiable();
			Label label = new Label(defPanel, SWT.WRAP);
			gridData = new GridData();
			label.setLayoutData(gridData);
			label.setText(title);
			label.addMouseTrackListener(new MListener(item));
			Text fText;
			if (modifiable) fText = new Text(defPanel, SWT.SHADOW_IN | SWT.BORDER);
			else fText = new Text(defPanel, SWT.SHADOW_IN | SWT.BORDER | SWT.READ_ONLY);
			gridData = new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL);
			gridData.horizontalSpan = 2;
			fText.setLayoutData(gridData);
			fText.setText(value);
			return fText;
		}
		
		protected Button createLabeledCheck(
			DriverDefinitionProperty item,
			Composite defPanel) {
			GridData gridData;
			String title = item.getLabel();
			boolean value;
			if (!ProjectProperties.getSelDriverProperty(curproject.getProject(), item.getId()).equals(""))
				value = "true".equals(ProjectProperties.getSelDriverProperty(curproject.getProject(), item.getId()));
			else value = item.getDefaultValue().equals("true");
			Label label = new Label(defPanel, SWT.WRAP);
			gridData = new GridData();
			label.setLayoutData(gridData);
			label.setText(title);
			label.addMouseTrackListener(new MListener(item));
			Button fButton = new Button(defPanel, SWT.CHECK);
			gridData =
				new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL);
			gridData.horizontalSpan = 2;
			fButton.setLayoutData(gridData);
			fButton.setSelection(value);
			return fButton;
		}
		
		protected Text createLabeledPath(
			DriverDefinitionProperty item,
			Composite defPanel) {
			GridData gridData;
			String title = item.getLabel();
			String value = ProjectProperties.getSelDriverProperty(curproject.getProject(), item.getId());
			Label label = new Label(defPanel, SWT.WRAP);
			gridData = new GridData();
			//gridData.horizontalSpan = 1;
			label.setLayoutData(gridData);
			label.setText(title);
			label.addMouseTrackListener(new MListener(item));
			final Text fText = new Text(defPanel, SWT.SHADOW_IN | SWT.BORDER);
			gridData =
				new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL);
			gridData.horizontalSpan = 1;
			fText.setLayoutData(gridData);
			fText.setText(value);
			final String fpath = value;
			Button fButton = new Button(defPanel, SWT.PUSH);
			fButton.setText("...");
			fButton.setLayoutData(new GridData());
			fButton.addSelectionListener(new SelectionListener() {
				public void widgetSelected(SelectionEvent e) {
					DirectoryDialog dlg = new DirectoryDialog(getControl().getShell());
					dlg.setFilterPath(fText.getText());
					String res = dlg.open();
					if (res != null) {
						fText.setText(res);
					}
				}

				public void widgetDefaultSelected(SelectionEvent e) {
					widgetSelected(e);
				}

			});

			return fText;
		}

		public class MListener implements MouseTrackListener{

			private DriverDefinitionProperty prop;
			
			public MListener(DriverDefinitionProperty item){
				this.prop = item;
			}
			
			/* (non-Javadoc)
			 * @see org.eclipse.swt.events.MouseTrackListener#mouseEnter(org.eclipse.swt.events.MouseEvent)
			 */
			public void mouseEnter(MouseEvent e) {
				descText.setText(prop.getDesc());
				
			}

			/* (non-Javadoc)
			 * @see org.eclipse.swt.events.MouseTrackListener#mouseExit(org.eclipse.swt.events.MouseEvent)
			 */
			public void mouseExit(MouseEvent e) {
				descText.setText(grpdesc[curgrp]);
			}

			/* (non-Javadoc)
			 * @see org.eclipse.swt.events.MouseTrackListener#mouseHover(org.eclipse.swt.events.MouseEvent)
			 */
			public void mouseHover(MouseEvent e) {
				
			}
		}

		protected Text createLabeledFile(
			DriverDefinitionProperty item,
			Composite defPanel,
			String extension) {
			GridData gridData;
			String title = item.getLabel();
			String value = ProjectProperties.getSelDriverProperty(curproject.getProject(), item.getId());
			Label label = new Label(defPanel, SWT.WRAP);
			gridData = new GridData();
			//gridData.horizontalSpan = 1;
			label.setLayoutData(gridData);
			label.setText(title);
			label.addMouseTrackListener(new MListener(item));
			final String s = extension;
			final Text fText = new Text(defPanel, SWT.SHADOW_IN | SWT.BORDER);
			gridData =
				new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL);
			gridData.horizontalSpan = 1;
			fText.setLayoutData(gridData);
			fText.setText(value);
			//if ((!"".equals(value))&&item.getType()==DriverDefinitionProperty.PCLASSPATH&&(value!=null)) removeFromClasspath(new Path(value));

			Button fButton = new Button(defPanel, SWT.PUSH);
			fButton.setText("...");
			fButton.setLayoutData(new GridData());
			fButton.addSelectionListener(new SelectionListener() {
				public void widgetSelected(SelectionEvent e) {
					FileDialog dlg = new FileDialog(getControl().getShell());
					dlg.setFilterExtensions(new String[] {s});
					dlg.setFileName(fText.getText());
					String res = dlg.open();
					if (res != null) {
						fText.setText(res);
					}
				}

				public void widgetDefaultSelected(SelectionEvent e) {
					widgetSelected(e);
				}

			});

			return fText;
		}



	}
	
	/**
	 * @see org.eclipse.jface.preference.IPreferencePage#performOk()
	 */
	public boolean performOk()	{
		try {
			int contCount = 0;
			ArrayList propertiesLines = new ArrayList();
			if (selectedDriverIndex >= 0) {
				DriverDefinition def = (DriverDefinition) definitions.get(selectedDriverIndex);
				ProjectProperties.setProjectProperty(curproject.getProject(), def.getName(),"Driver");
				Iterator groups = def.getJDOprojconf().getGroups().iterator();
				while (groups.hasNext()){
					JDOProjectConfGroup curgroup = (JDOProjectConfGroup) groups.next();
					Iterator properties = curgroup.getProperties().iterator();
					while (properties.hasNext()) {
						DriverDefinitionProperty item = (DriverDefinitionProperty) properties.next();
						Control control = (Control) selectedControls.get(contCount++);
						switch (item.getType()) {
							case DriverDefinitionProperty.BOOLEAN :
								item.setTempValue("" + ((Button) control).getSelection());							
								break;
							case DriverDefinitionProperty.DIRECTORY :
							case DriverDefinitionProperty.FILE :
							case DriverDefinitionProperty.PCLASSPATH :
								if ((((Text) control).getText() != null)&&(((Text) control).getText() != "")){
									item.setTempValue(((Text) control).getText().replace('\\', '/'));
									newpclasspath.add(((Text) control).getText().replace('\\', '/'));
								}
								break;
							case DriverDefinitionProperty.EFOLDER :
								if ((((Text) control).getText() != null)&&(((Text) control).getText() != "")){
									item.setTempValue(((Text) control).getText().replace('/', File.separatorChar));
								}
							break;
							case DriverDefinitionProperty.COMBO :
								item.setTempValue(((Combo) control).getText());
								break;
							case DriverDefinitionProperty.STRING :
							default :
								item.setTempValue(((Text) control).getText());
								break;
						}
					}
					String temp = null;	
					for (Iterator ite = curgroup.getProperties().iterator();ite.hasNext();){
						DriverDefinitionProperty curprop = (DriverDefinitionProperty) ite.next();
						ProjectProperties.setProjectProperty(curproject.getProject(), (String) curprop.getTempValue(), ProjectProperties.getProjectProperty(curproject.getProject(), "Driver") +"_"+ curprop.getId());
						temp = ProjectProperties.getSelDriverProperty(curproject.getProject(), curprop.getId());
						if ((!temp.equals(""))&&(!(temp == null))) propertiesLines.add("\n"+curprop.getId()+" "+ProjectProperties.getSelDriverProperty(curproject.getProject(), curprop.getId())+"\n\n");	
					}
				}
				


				// Creating Speedo properties file
				String temp = null;	
				for (Iterator ite = def.getEclipsePreferencesProperties().iterator();ite.hasNext();){
					DriverDefinitionProperty curprop = (DriverDefinitionProperty) ite.next();
					ProjectProperties.setProjectProperty(curproject.getProject(), (String) curprop.getDefaultValue(), ProjectProperties.getProjectProperty(curproject.getProject(), "Driver") +"_"+ curprop.getId());
					temp = ProjectProperties.getSelDriverProperty(curproject.getProject(), curprop.getId());
					if ((!temp.equals(""))&&(!(temp == null))) propertiesLines.add("\n"+curprop.getId()+" "+ProjectProperties.getSelDriverProperty(curproject.getProject(), curprop.getId())+"\n\n");			
				}
				File f = PropertiesFileGen.genPropertiesFile(new File(Platform.getLocation().toOSString()+curproject.getPath().toOSString()+File.separator+"enhancer.properties"),
															 propertiesLines);

			}
													
			// Updating ClassPath...
			for (Iterator ite = oldpclasspath.iterator(); ite.hasNext();){
				removeFromClasspath(new Path((String) ite.next()));
			}
			setnewPCP();
			String oldpClasspath = "";
			for (Iterator ite = newpclasspath.iterator();ite.hasNext();){
				oldpClasspath = oldpClasspath.concat((String) ite.next() + " ");
			}
			ProjectProperties.setProjectProperty(curproject.getProject(), oldpClasspath, "oldPCP");
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		return true;
	}


	private void setnewPCP() {

		try {
			IClasspathEntry[] oldcpe = curproject.getRawClasspath();
			IClasspathEntry[] newcpe = new IClasspathEntry[oldcpe.length+newpclasspath.size()];
			System.arraycopy(oldcpe, 0, newcpe, 0, oldcpe.length);
			int index = oldcpe.length;
			ClasspathItem cpItem;
			for (Iterator ite = newpclasspath.iterator(); ite.hasNext();){
				newcpe[index++] = JavaCore.newLibraryEntry(new Path((String)ite.next()),null,null);
			}
			curproject.setRawClasspath(newcpe, new NullProgressMonitor());
		} catch (JavaModelException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}




	private void removeFromClasspath(Path path)  {
		try {
			IClasspathEntry[] oldcpe = curproject.getRawClasspath();
			IClasspathEntry[] newcpe = new IClasspathEntry[oldcpe.length-1];
			int count = 0;
			for (int i=0; i<oldcpe.length;i++){
				if (!path.equals(oldcpe[i].getPath())) {
					newcpe[count++] = oldcpe[i]; 
				}
			}

			curproject.setRawClasspath(newcpe, new NullProgressMonitor());
		} catch (JavaModelException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		} 
			
	}
}
