
package org.objectweb.eclipsespeedo.utils;

import java.util.Iterator;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.ForStatement;
import org.eclipse.jdt.internal.corext.dom.ASTWithExistingFlattener;


public class ASTFixFlattener extends ASTWithExistingFlattener {
	public boolean visit(ForStatement node)	{
		fResult.append("for (");
		for (Iterator it = node.initializers().iterator(); it.hasNext();)
		{
			Expression e = (Expression) it.next();
			e.accept(this);
		}
		fResult.append("; ");
		if (node.getExpression() != null)
		{
			node.getExpression().accept(this);
		}
		fResult.append("; ");
		for (Iterator it = node.updaters().iterator(); it.hasNext();)
		{
			Expression e = (Expression) it.next();
			e.accept(this);
		}
		fResult.append(") ");
		node.getBody().accept(this);
		return false;
	}
}
