/*
 * Created on Apr 7, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */
package org.objectweb.eclipsespeedo.utils;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.ResourceBundle;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.core.IJavaProject;
import org.objectweb.eclipsespeedo.project.EclipseSpeedoProjectHelper;


public class PropertiesFileGen {
	
	static public File genPropertiesFile(File outputFile, ArrayList propertiesLines) throws CoreException, IOException {

		if (outputFile.exists()) outputFile.delete();
		outputFile.createNewFile();
		FileOutputStream fos = new FileOutputStream(outputFile);
			
		for (Iterator ite = propertiesLines.iterator();ite.hasNext();) {
			fos.write(((String)ite.next()).getBytes());
		}
		return outputFile;
	}
	
	static public File genPropertiesFile(String resource, File outputFile, HashMap map1, HashMap map2, IJavaProject p) throws CoreException, IOException {

		try {
			if (outputFile.exists()) outputFile.delete();
			outputFile.createNewFile();
			InputStream is= (new EclipseSpeedoProjectHelper()).getClass().getClassLoader().getResourceAsStream(resource);
			FileOutputStream fos = new FileOutputStream(outputFile);
			while (is.available()!=0){
				byte[] buf = new byte[is.available()];
				is.read(buf);
				fos.write(buf);
			}

			

			fos.write((new String("\nhandler.fileHandler.type File\nhandler.fileHandler.output "+Platform.getLocation().toString()+p.getPath().toString()+"/"+"speedo.log"+"\n").getBytes()));
			fos.write((new String("handler.fileHandler.pattern [%l] %m%n\n").getBytes()));
			fos.write((new String("logger.root.handler.1 fileHandler\n\n\n").getBytes()));
			

		/*	fos.write((new String("\nhandler.consoleHandler.type Console\n").getBytes()));
			fos.write((new String("handler.consoleHandler.output System.out\n").getBytes()));
			fos.write((new String("handler.consoleHandler.pattern [%l] %m%n\n").getBytes()));
			fos.write((new String("logger.root.handler.0 consoleHandler\n\n\n").getBytes()));*/
			
			
			String key;
			String value;
			fos.write(("###################################\n" +
					   "#    Generation Logs              #\n" +
					   "###################################\n\n").getBytes());
			for (Iterator ite = map1.keySet().iterator(); ite.hasNext();) {
				key = (String) ite.next();
				value = (String) map1.get(key);
				fos.write((key+" "+value+"\n").getBytes());
			}
			fos.write(("\n\n\n###################################\n" +
					   "#   Runtime Logs                  #\n" +
					   "###################################\n\n").getBytes());
			for (Iterator ite = map2.keySet().iterator(); ite.hasNext();) {
				key = (String) ite.next();
				value = (String) map2.get(key);
				fos.write((key+" "+value+"\n").getBytes());
			}
			return outputFile;
		}
		catch (Exception e){
			return null;
		}
	}
	
	
	static public HashMap setLoggersLevels(String Bundlename, String level){
		ResourceBundle resourceBundle= ResourceBundle.getBundle("org.objectweb.eclipsespeedo."+Bundlename);
		HashMap res = new HashMap(); 
		Enumeration keys = resourceBundle.getKeys();
		while (keys.hasMoreElements()) {
			res.put(keys.nextElement(), level);
		}
		return res;
	}
}
