/*
 * Created on Apr 9, 2004
 * author: VEZIER Antoine
 * Internship Master: Hamon Catherine
 * 
 */
package org.objectweb.eclipsespeedo.utils;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.internal.core.JavaProject;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.eclipsespeedo.IEclipseSpeedoConstants;


public class SelectionTools {
	
	public static boolean ensureSpeedoProjectSelected(IWorkbenchWindow win){
		EclipseSpeedoPlugin p = EclipseSpeedoPlugin.getDefault();
		StructuredSelection ss = (StructuredSelection) p.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
		try {
			JavaProject pr = (JavaProject)ss.getFirstElement();
			if (pr.getProject().getNature(IEclipseSpeedoConstants.PROJECT_NATURE_ID)==null) {
				UITools.selectionError("You must select a Speedo Project before!", win);
				return false;
			}
		} catch (CoreException e) {
			e.printStackTrace();
			return false;
		} catch (ClassCastException e1) {
			UITools.selectionError("You must select a Speedo Project before!", win);
			return false;
		}
		catch (Exception e2) {
			UITools.selectionError("You must select a Speedo Project before!", win);
			return false;
		}
		return true;
	}
	
	public static boolean ensureSpeedoPackageorSFileSelected(IWorkbenchWindow win){
		EclipseSpeedoPlugin p = EclipseSpeedoPlugin.getDefault();
		StructuredSelection ss = (StructuredSelection) p.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
		IJavaElement jEl;
		try {
			Object o = ss.getFirstElement();
			jEl = (IJavaElement) o;

			if (jEl.getJavaProject().getProject().getNature(IEclipseSpeedoConstants.PROJECT_NATURE_ID)==null) {
				UITools.selectionError("For this action, \n" +
					"You must before select a package or source file belonging to a Speedo Project!", win);
				return false;
			}
		} catch (Exception e) {
			UITools.selectionError("For this action, \n" +
					"You must before select a package or source file belonging to a Speedo Project!", win);
			return false;
		}
		if (!((jEl.getElementType()==IJavaElement.PACKAGE_FRAGMENT)||(jEl.getElementType()==IJavaElement.COMPILATION_UNIT))){
			UITools.selectionError("For this action, \n" +
					"You must before select a package or source file belonging to a Speedo Project!", win);
			return false;
		}
		return true;
	}
	
	public static boolean ensureSpeedoElementSelected(IWorkbenchWindow win){
		EclipseSpeedoPlugin p;
		StructuredSelection ss;
		IJavaElement jEl;
		Object o;
		try {
			p = EclipseSpeedoPlugin.getDefault();
			ss = (StructuredSelection) p.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
			o = ss.getFirstElement();
			jEl = (IJavaElement) o;

			if (jEl.getJavaProject().getProject().getNature(IEclipseSpeedoConstants.PROJECT_NATURE_ID)==null) {
				UITools.selectionError("For this action, you must before select a Speedo element : Project, Package, Java file or Class", win);
				return false;
			}
		} catch (Exception e) {
			UITools.selectionError("For this action, you must before select a Speedo element : Project, Package, Java file or Class", win);
			return false;
		}
		return true;
	}

	public static IType[] getMainClasses(IType[] classes) {
		IMethod[] curclas;
		IType[] res;
		IType[] tempres = new IType[classes.length];
		int count=0;
		for (int i=0;i<classes.length;i++){
			try {
				curclas = classes[i].getMethods();
				for (int j=0;j<curclas.length;j++){
					if (curclas[j].isMainMethod()){
						tempres[count] = classes[i];
						count++;
						break;
					}
				}
			} catch (Exception e) {
				return null;
			}
		}
		res = new IType[count];
		System.arraycopy(tempres, 0, res, 0, count);
		return res;
	}
}