package org.objectweb.eclipsespeedo.wizards;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.wizard.Wizard;
import org.objectweb.eclipsespeedo.EclipseSpeedoPlugin;
import org.objectweb.eclipsespeedo.actions.MainCreation;


/**
 * Main class of the main creation wizard Allow to choose the java file , and
 * to create jdo properties configuration. It also add the necessary imports
 * and the JDO classpath entry
 */
public class MainCreationWizard extends Wizard
{
	private IJavaElement jEl;
	private IJavaProject jp;
	private IPreferenceStore st;
	private MainCreation mainCreation;

	/**
	 * Constructor. Setup the java project
	 * 
	 * @param projectName
	 */

	public MainCreationWizard(IJavaElement jEl)	{
		super();
		this.jEl = jEl;
		jp = this.jEl.getJavaProject();
		st = EclipseSpeedoPlugin.getDefault().getPreferenceStore();
	}

	private MainCreationWizardPage page;

	public void addPages() {
		page = new MainCreationWizardPage(this.jEl);
		addPage(page);
		this.mainCreation = new MainCreation(page, jp.getProject());
	}


	public boolean performFinish() {
		return mainCreation.doChange();
	}
}
