package org.objectweb.eclipsespeedo.xml.resource;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.xmi.XMLHelper;
import org.eclipse.emf.ecore.xmi.XMLLoad;
import org.eclipse.emf.ecore.xmi.XMLResource;
import org.eclipse.emf.ecore.xmi.XMLSave;
import org.eclipse.emf.ecore.xmi.impl.XMLMapImpl;
import org.eclipse.emf.ecore.xmi.impl.XMLResourceImpl;
import org.objectweb.eclipsespeedo.metadata.MetadataPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>XML Resource</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 */
public class DTDXMLResourceImpl extends XMLResourceImpl {
	static XMLMap xmlMap = null;

	static XMLMap getMetadataMap() {
		if (xmlMap == null) {
			xmlMap = new XMLMapImpl();

			xmlMap.setNoNamespacePackage(MetadataPackage.eINSTANCE);
		}
		return xmlMap;
	}

	/**
	 */
	protected DTDXMLResourceImpl() {
		super();
	}

	/**
	 * Constructor for XMLResourceImpl.
	 * @param uri
	 */
	public DTDXMLResourceImpl(URI uri) {
		super(uri);

		getDefaultSaveOptions().put(
			XMLResource.OPTION_XML_MAP,
			getMetadataMap());
		getDefaultLoadOptions().put(
			XMLResource.OPTION_XML_MAP,
			getMetadataMap());
	}

	protected XMLLoad createXMLLoad() {
		XMLHelper helper = createXMLHelper();
		helper.setNoNamespacePackage(MetadataPackage.eINSTANCE);
		return new DTDXMLLoadImpl(helper);
	}

	protected XMLSave createXMLSave() {
		XMLHelper helper = createXMLHelper();
		helper.setNoNamespacePackage(MetadataPackage.eINSTANCE);
		return new DTDXMLSaveImpl(helper);
	}
} //XMLResourceImpl
