package org.objectweb.eclipsespeedo.xml.resource;

import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.xmi.XMLHelper;
import org.eclipse.emf.ecore.xmi.XMLResource;
import org.eclipse.emf.ecore.xmi.impl.XMLSaveImpl;
import org.objectweb.eclipsespeedo.project.EclipseSpeedoProjectHelper;


public class DTDXMLSaveImpl extends XMLSaveImpl
{
	/**
	 * @param helper
	 */
	public DTDXMLSaveImpl(XMLHelper helper)
	{
		super(helper);
	}

	public void traverse(List contents)
	{
		if (declareXML)
		{
			XMLResource resource = helper.getResource();
			String metaDataDocType =
				EclipseSpeedoProjectHelper.findMetadataDocType();

			doc.add(
				"<?xml version=\""
					+ XML_VERSION
					+ "\" encoding=\""
					+ encoding
					+ "\"?>");
			doc.addLine();
			if (metaDataDocType != null && metaDataDocType.length() > 0)
			{
				doc.add("<!DOCTYPE jdo " + metaDataDocType + ">");
				doc.addLine();
			}
		}

		int size = contents.size();

		// Reserve a place to insert xmlns declarations after we know what they
		// all are.
		//
		Object mark;

		if (size == 1)
		{
			mark = writeTopObject((EObject) contents.get(0));
		}
		else
		{
			mark = writeTopObjects(contents);
		}

		// Go back and add all the XMLNS stuff.
		//
		doc.resetToMark(mark);
		addNamespaceDeclarations();
	}
}
