package org.objectweb.eclipsespeedo.xml.resource;

//eclipse import

import java.io.InputStreamReader;

import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;

/**
 * This class is used to find the rigth jdo dtd
 * It implies that the jdo.jar is included in the plugin classpath
 */
public class JDOResolver implements EntityResolver {
	public InputSource resolveEntity(String publicId, String systemId) {
		if (systemId.endsWith("jdo.dtd")) {
			// the jdo.dtd file is in jdo.jar at javax/jdo/jdo.dtd
			java.io.InputStream inputstream =
				getClass().getClassLoader().getResourceAsStream(
					"javax/jdo/jdo.dtd");
			if (inputstream != null)
				return new InputSource(new InputStreamReader(inputstream));
		}
		//if we don't find it we return null;
		return null;
	}
}
