/**
 * Copyright (C) 2001-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package org.objectweb.speedo.generation.start;

/**
 * Support for signalling internal implementation errors.
 */
public class Assertion {

    static protected final void assertion(boolean condition) {
        if (!condition)
            throw new InternalError("assertion failed.");
    }

    static protected final void assertion(boolean condition, String msg) {
        if (!condition)
            throw new InternalError("assertion failed: " + msg);
    }

    static protected final void assertion(Object object) {
        if (object == null)
            throw new InternalError("assertion failed.");
    }

    static protected final void assertion(Object object, String msg) {
        if (object == null)
            throw new InternalError("assertion failed: " + msg);
    }
}
