/**
 * Copyright (C) 2001-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.pobjects.collection;

import java.util.Collection;
import java.util.Set;
import java.util.List;
import java.util.HashSet;
import java.util.ArrayList;
import java.util.Vector;
import java.util.LinkedList;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class AllCollection {

    private String id;

    private Collection col_Long;
    private Collection col_ref;

    private Set set_Long;
    private Set set_ref;
    private HashSet hset_Long;
    private HashSet hset_ref;

    private List list_Long;
    private List list_ref;
    private ArrayList arraylist_Long;
    private ArrayList arraylist_ref;
    private Vector vector_Long;
    private Vector vector_ref;
    private LinkedList ll_Long;
    private LinkedList ll_ref;

    public AllCollection() {
    }

    public AllCollection(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public void setLongs(long[] ls) {
    	if (ls == null) {
            col_Long = null;
            set_Long = null;
            list_Long = null;
            hset_Long = null;
            arraylist_Long = null;
            vector_Long = null;
            ll_Long = null;
        } else {
            col_Long = new ArrayList();
            set_Long = new HashSet();
            list_Long = new ArrayList();
            hset_Long = new HashSet();
            arraylist_Long = new ArrayList();
            vector_Long = new Vector();
            ll_Long = new LinkedList();
            for(int i=0; i<ls.length; i++) {
            	Long l = new Long(ls[i]);
                col_Long.add(l);
                set_Long.add(l);
                list_Long.add(l);
                hset_Long.add(l);
                arraylist_Long.add(l);
                vector_Long.add(l);
                ll_Long.add(l);
            }
        }
    }

    public void setRefs(Object[] os) {
        if (os == null) {
            col_ref = null;
            set_ref = null;
            list_ref = null;
            hset_ref = null;
            arraylist_ref = null;
            vector_ref = null;
            ll_ref = null;
        } else {
            col_ref = new ArrayList();
            set_ref = new HashSet();
            list_ref = new ArrayList();
            hset_ref = new HashSet();
            arraylist_ref = new ArrayList();
            vector_ref = new Vector();
            ll_ref = new LinkedList();
            for(int i=0; i<os.length; i++) {
                col_ref.add(os[i]);
                set_ref.add(os[i]);
                list_ref.add(os[i]);
                hset_ref.add(os[i]);
                arraylist_ref.add(os[i]);
                vector_ref.add(os[i]);
                ll_ref.add(os[i]);
            }
        }
    }


    public Collection getCol_Long() {
        return col_Long;
    }

    public Collection getCol_ref() {
        return col_ref;
    }

    public Set getSet_Long() {
        return set_Long;
    }

    public Set getSet_ref() {
        return set_ref;
    }

    public List getList_Long() {
        return list_Long;
    }

    public List getList_ref() {
        return list_ref;
    }

    public HashSet getHset_Long() {
        return hset_Long;
    }

    public HashSet getHset_ref() {
        return hset_ref;
    }

    public ArrayList getArraylist_Long() {
        return arraylist_Long;
    }

    public ArrayList getArraylist_ref() {
        return arraylist_ref;
    }

    public Vector getVector_Long() {
        return vector_Long;
    }

    public Vector getVector_ref() {
        return vector_ref;
    }

    public LinkedList getLl_Long() {
        return ll_Long;
    }

    public LinkedList getLl_ref() {
        return ll_ref;
    }
}
