/**
 * Speedo: an implementation of JDO compliant personality on top of JORM generic
 * I/O sub-system.
 * Copyright (C) 2001-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *
 * Contact: speedo@objectweb.org
 *
 */
package org.objectweb.speedo.pobjects.detach;

import java.util.Collection;
import java.util.Iterator;
/**
 * @author Y.Bersihand
 */
public class Team {
	
	protected String town;
	protected Collection players;
	protected Coach coach;
	
	public Team(String town, Collection players, Coach coach){
		this.town = town;
		this.players = players;
		this.coach  = coach;
	}
	
	public Coach getCoach() {
		return coach;
	}

	public Collection getPlayers() {
		return players;
	}

	public String getTown() {
		return town;
	}

	public void setCoach(Coach coach) {
		this.coach = coach;
	}

	public void setPlayers(Collection collection) {
		players = collection;
	}

	public void addPlayer(Player p){
		players.add(p);
	}
	
	public void setTown(String string) {
		town = string;
	}

	public String toString(){
		String s =  "Team[" + town + ", " + coach.toString() + ", ";
		Iterator it = players.iterator();
		while(it.hasNext()){
			Player p = (Player) it.next();
			s += p.toString() + " ";
		}
		s+= " ]";
		return s;
	}
}
