package org.objectweb.speedo.pobjects.userid;

import java.util.Date;
import java.util.Collection;

/**
 * Table des conventions.
 *
 * TSMF7B00
 *
 * @persistent
 * @rdbPhysicalName ConventionHelper
 * @rdbPhysicalPrimaryKeyName DSMF7B00
 */
public class ConventionHelper  {

  /** Identifiant unique de srialisation */
  static final private long serialVersionUID = 0;

  /**
   * @rdbPhysicalName DDMEC
   * @rdbNotNull
   * @rdbSize 7
   * @rdbDigits 0
   * @rdbLogicalType Date
   * @rdbPrimaryKey
   */
  private Date ddmec;

  /** Code marque */
  private String cdmem;

  /** Code domaine */
  private String cdmed;

  /** Code comptence */
  private String cdmec;

  /** Code spcialit lmentaire */
  private String cdmese;

  /** Code intervenant */
  private long nomep;
  
    /**
   * @rdbPhysicalName KSMF7B00
   * @rdbIdentifying
   */
  private IntervenantHelper intervenant;

  public String getCdmec() {
    return cdmec;
  }

  public String getCdmem() {
    return cdmem;
  }

  public String getCdmed() {
    return cdmed;
  }

  public IntervenantHelper getIntervenant() {
    return intervenant;
  }

  public long getNomep() {
    return nomep;
  }

  public Date getDdmec() {
    return ddmec;
  }

  public String getCdmese() {
    return cdmese;
  }

  public void setCdmec(String pCdmec) {
    this.cdmec = pCdmec;
  }

  public void setCdmem(String pCdmem) {
    this.cdmem = pCdmem;
  }

  public void setCdmed(String pCdmed) {
    this.cdmed = pCdmed;
  }

  public void setIntervenant(IntervenantHelper pIntervenant) {
    this.intervenant = pIntervenant;
  }

  public void setNomep(long pNomep) {
    this.nomep = pNomep;
  }

  public void setDdmec(Date pDdmec) {
    this.ddmec = pDdmec;
  }

  public void setCdmese(String pCdmese) {
    this.cdmese = pCdmese;
  }

  /**
   * Constructeur par dfaut.
   */
  public ConventionHelper() {
  }

}
