/**
 * Copyright (C) 2001-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.pobjects.userid;

import java.io.Serializable;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class InnerUserId {
	private String f1;
	private int f2;
	private long oid1;
	private long oid2;

	public InnerUserId() {
	}

	public InnerUserId(String f1, int f2, long oid1, long oid2) {
		this.f1 = f1;
		this.f2 = f2;
		this.oid1 = oid1;
		this.oid2 = oid2;
	}

	public InnerUserId(String f1, int f2, Oid oid) {
		this.f1 = f1;
		this.f2 = f2;
		oid1 = oid.oid1;
		oid2 = oid.oid2;
	}

	public String getF1() {
		return f1;
	}

	public int getF2() {
		return f2;
	}

	public long getOid1() {
		return oid1;
	}

	public long getOid2() {
		return oid2;
	}

	/**
	 *This class is used to represent the application identifier
	 for the <code>InnerUserId</code> class.
	 */
	public static class Oid implements Serializable {
		public long oid1;
		public long oid2;

		/**
		 *The required public, null constructor.
		 */
		public Oid() {
			oid1 = 0;
			oid2 = 0;
		}

		/**
		 *A constructor to initialize the identifier field.
		 */
		public Oid(long o1, long o2) {
			oid1 = o1;
			oid2 = o2;
		}

		public boolean equals(java.lang.Object obj) {
			if (obj == null || !this.getClass().equals(obj.getClass()))
				return (false);
			return oid1 == ((Oid) obj).oid1 && oid2 == ((Oid) obj).oid2;
		}

		public int hashCode() {
			return ((int) oid1);
		}
	}

}
