/**
 * Copyright (C) 2001-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.runtime.collection;

import org.objectweb.speedo.SpeedoTestHelper;
import org.objectweb.speedo.pobjects.collection.G;
import org.objectweb.speedo.pobjects.collection.H;

import javax.jdo.PersistenceManager;
import java.util.Collection;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class TestGH extends SpeedoTestHelper {

	public TestGH(String s) {
		super(s);
	}

	protected String getLoggerName() {
		return LOG_NAME + ".rt.collection.TestGH";
	}

	public void testA() {
		int NBOBJ = 10;
		PersistenceManager pm = pmf.getPersistenceManager();
		pm.currentTransaction().begin();
		G g = new G("g1_testA");
		Collection hs = g.getHs();
		for(int i=0; i<NBOBJ; i++) {
			H h = new H("hid_" + i);
			h.setH1("h1_testA");
			hs.add(h);
		}
		pm.makePersistent(g);
		g = null;
		hs = null;
		pm.currentTransaction().commit();
		pm.evictAll();
		pm.close();
		pm = pmf.getPersistenceManager();
		pm.evictAll();
		pm.currentTransaction().begin();
		H h0 = (H) pm.getObjectById(pm.newObjectIdInstance(H.class, "hid_0"), false);
		assertNotNull("Null h0", h0);
		g = h0.getG();
		assertNotNull("Null g", g);
		pm.deletePersistentAll(g.getHs());
		pm.deletePersistent(g);
		pm.currentTransaction().commit();
		pm.close();

	}
}
