/**
 * Speedo: an implementation of JDO compliant personality on top of JORM generic
 * I/O sub-system.
 * Copyright (C) 2001-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *
 * Contact: speedo@objectweb.org
 *
 * Authors: S.Chassande-Barrioz.
 *
 */
package org.objectweb.speedo.j2eedo.ejb;
import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import org.objectweb.speedo.j2eedo.common.PMHolder;
import org.objectweb.speedo.j2eedo.bo.DatabaseImpl;
/**
 * Class StoreServicesBean
 * 
 * @author S.Rodiere
 *  
 */
public class StoreServicesBean implements SessionBean {
	private DatabaseImpl databaseImpl = null;
	private SessionContext context;
	/**
	 * Constructor StoreServicesBean
	 * 
	 *  
	 */
	public StoreServicesBean() {
	}
	/**
	 * Method ejbCreate
	 * 
	 * @throws CreateException
	 *  
	 */
	public void ejbCreate() throws CreateException {
	}
	/**
	 * Method ejbActivate
	 * 
	 *  
	 */
	public void ejbActivate() {
	}
	/**
	 * Method ejbPassivate
	 * 
	 *  
	 */
	public void ejbPassivate() {
	}
	/**
	 * Method ejbRemove
	 * 
	 *  
	 */
	public void ejbRemove() {
	}
	/**
	 * Method setSessionContext
	 * 
	 * @param ctx
	 *  
	 */
	public void setSessionContext(SessionContext ctx) {
		context = ctx;
	}
	/**
	 * @param persistenceManagerHolder is the persistence manager holder
	 * @param action is the action to be done
	 * @see org.objectweb.speedo.j2eedo.database.DatabaseImpl
	 * @return result of the method as a string
	 * @throws Exception
	 */
	public String doAction(PMHolder persistenceManagerHolder, String action)
		throws Exception {
		if (null == this.databaseImpl)
			databaseImpl = new DatabaseImpl(persistenceManagerHolder);
		return databaseImpl.doAction(action);
	}
}
